/* $Id: 3dbutton.h,v 1.1 90/06/17 18:44:42 gjb Exp $
 *
 *  ThreeDButton.h							*
 *									*
 *  Three-dimensional versions of the standard InterViews buttons.	*
 *									*
 *  By Greg Brail. Copyright 1990 Brown University.			*/

#ifndef DBUTTON_H
#define DBUTTON_H

#include <InterViews/button.h>

class ThreeDPushButton : public PushButton

{
public:
  ThreeDPushButton(const char*, ButtonState*, int);
  ThreeDPushButton(const char*, ButtonState*, void*);
  virtual void Reconfig();
  virtual void Refresh();
};

class ThreeDRadioButton : public RadioButton

{
public:
  ThreeDRadioButton(const char*, ButtonState*, int);
  ThreeDRadioButton(const char*, ButtonState*, void*);
  virtual void Reconfig();
  virtual void Redraw(Coord, Coord, Coord, Coord);
  virtual void Refresh();
};

class ThreeDCheckBox : public CheckBox

{
public:
  ThreeDCheckBox(const char*, ButtonState*, int, int);
  ThreeDCheckBox(const char*, ButtonState*, void*, void*);
  virtual void Reconfig();
  virtual void Redraw(Coord, Coord, Coord, Coord);
  virtual void Refresh();
};

#endif
