/*  $Id: 3dmenuitem.h,v 1.1 90/06/17 18:44:49 gjb Exp $
 *
 *  3DMenuItem: 							*
 *									*
 *  A 3-D look menu item.						*
 *									*
 *  By Greg Brail. Copyright 1990 Brown University.			*/
#ifndef DMENUITEM_H
#define DMENUITEM_H

class Event;
class Color;

#include <InterViews/menu.h>

class ThreeDMenuItem : public Control

{
public:
  ThreeDMenuItem(const char* name, char* key = "");
  ~ThreeDMenuItem();
  virtual void Reconfig();				// Set up shape and stuff
  virtual void Draw();					// Draw whole thing
  virtual void Redraw(Coord, Coord, Coord, Coord);
  virtual void Highlight(boolean high);			// Highlight or unhighlight
  void Enable();
  void Disable();
protected:
  char* text;						// Text of the menu
  boolean enabled;					// Whether it responds to inputs
  boolean highlighted;					// Whether to draw highlighted
  Color* dimmed;					// Color to draw when highlighted
  char* whatKey;					// What key to read
};

#endif

