#ifndef _DiamondBeveller_h
#define _DiamondBeveller_h

static char _rcs_id_DiamondBeveller_h[] = "DATAP $Source: /usr/datap/include/Iv/RCS/DiamondBeveller.h,v $ $Revision: 1.3 $";

// Copyright (c) DATAP Systems, 1991. All rights reserved.
// License material - Property of DATAP Systems.
//
// Project: 987050 C 440
// Library: Iv
// File: DiamondBeveller.cc


/*
 * Revision History:
 *   $Log: DiamondBeveller.h,v $
 * Revision 1.3  1991/10/11  14:39:38  pbrown
 * Added const for parameters for new IV 3.0 release.
 *
 * Revision 1.2  1991/08/27  20:26:56  morrison
 * Brought up to date for code inspection
 *
 * Revision 1.1  1991/07/15  20:09:30  morrison
 * Initial revision
 *
 */

// Section: Description
//   This routine draws the diamond shape used in motif radio buttons.
//   This includes the light/shadow effects to provide the 3D look.
//   

// Section: Usage Hints
//   Call this routine with the lightest color passed as the parameter 
//   'light' when you want an 'unselected' diamond (looks like it stands
//   out from the display).  Reverse light and dark to create the 
//   'selected' look (the diamond appears pressed into the display).
//   

#include <IV-look/bevel.h>

void diamond(
    Canvas* canvas, const Color* light, const Color* medium, const Color* dark, Coord thickness,
    Coord left, Coord bottom, Coord right, Coord top);

#endif
