

#include <IV-look/kit.h>
#include <IV-look/button.h>
#include <InterViews/action.h>
#include <InterViews/box.h>
#include <InterViews/background.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>

class App : public MonoGlyph {
public:
  App(Kit* kit, Style* style);
  void hit01(), hit02();
};

declare(ActionCallback,App);
implement(ActionCallback,App);

App::App(Kit* kit, Style* style) : MonoGlyph(nil) {
    body(new LRBox(kit->simple_push_button("01", style,   
		     new ActionCallback(App)(this, &App::hit01)),
                   kit->simple_push_button("02", style,   
		     new ActionCallback(App)(this, &App::hit02))));
}

extern "C" puts(char*);
void App::hit01() { puts ("hit 01"); this->replace(0, this->component(1)); }
void App::hit02() { puts ("hit 02"); }

main(int argc, char** argv) {
  Session* session = new Session("foo", argc, argv);
  Style* style = session->style();
  Kit* kit = Kit::instance();
  session->run_window(new ApplicationWindow(new App(kit, style)));
}

/*
>>>>From: schwartz@roke.cs.psu.edu (Scott Schwartz)
Newsgroups: comp.windows.interviews
Subject: Re: How to dynamically update boxes?
Message-ID: <rr8H2ciz6@cs.psu.edu>
Date: 24 Apr 92 19:46:39 GMT
References: <1992Apr22.181843.12355@cc.gatech.edu>
Sender: news@cs.psu.edu (Usenet)
Organization: penn state university, computer science
Lines: 38
In-Reply-To: hernan@cc.gatech.edu's message of Wed, 22 Apr 1992 18:18:43 GMT
Nntp-Posting-Host: roke.cs.psu.edu


I've had similar difficulties.  Is this code wildly incorrect?
*/

