#include <InterViews/painter.h> 
#include <InterViews/shape.h> 
#include <InterViews/sensor.h> 
#include <InterViews/world.h> 
#include <InterViews/adjuster.h> 
#include <InterViews/border.h> 
#include <InterViews/box.h> 
#include <InterViews/button.h> 
#include <InterViews/strbrowser.h> 
#include <InterViews/frame.h> 
#include <InterViews/glue.h> 
#include <InterViews/message.h> 
#include <InterViews/menu.h>
#include <InterViews/scroller.h> 
#include <InterViews/streditor.h> 
#include <InterViews/texteditor.h> 
#include <InterViews/textbuffer.h> 
#include "Iedit.h"
#include <InterViews/2.6/_enter.h>


typedef void (Iedit_core::*Iedit_core_Func)();

class Iedit_core_Menu : public MenuItem {
public:
    Iedit_core_Menu(const char*,  const char*, Alignment, Iedit_core*, Iedit_core_Func = nil);
    virtual void Do();
private:
    Iedit_core_Func _func;
    Iedit_core* _coreclass;
};

Iedit_core_Menu::Iedit_core_Menu(
    const char* instance, const char* str, Alignment al, Iedit_core* coreclass, Iedit_core_Func f
) : MenuItem(str, al) {
    _func = f;
    _coreclass = coreclass;
    SetInstance(instance);
}

void Iedit_core_Menu::Do() {
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

class Shaper : public MonoScene {
public:
    Shaper(const char*, int, int, int, int, int, int);
    void Reconfig();
private:
    int _h, _v;
    int _hstr, _vstr;
    int _hshr, _vshr;
};

Shaper::Shaper (
    const char* name, int h, int v, int hstr, int vstr, int hshr, int vshr) {
    SetInstance(name);
    _h = h, _v = v;
    _hstr = hstr, _vstr = vstr;
    _hshr = hshr, _vshr = vshr;
}

void Shaper::Reconfig () {
    MonoScene::Reconfig();
    shape->width = _h;
    shape->height = _v;
    shape->hstretch = _hstr;
    shape->vstretch = _vstr;
    shape->hshrink = _hshr;
    shape->vshrink = _vshr;
}

typedef void (Iedit_core::*Iedit_core_BFunc)();

class Iedit_core_Button : public ButtonState {
public:
    Iedit_core_Button(
	int, Iedit_core* = nil, Iedit_core_BFunc = nil
    );
    virtual void Notify();
private:
    Iedit_core_BFunc _func;
    Iedit_core* _coreclass;
};

Iedit_core_Button::Iedit_core_Button(
    int i, Iedit_core* coreclass, Iedit_core_BFunc f
) : ButtonState(i) {
    _func = f;
    _coreclass = coreclass;
}

void Iedit_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

Iedit_core::Iedit_core(const char* name) {
    SetInstance(name);
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    Insert(Interior());
}

Interactor* Iedit_core::Interior() {
    fileNameBS = new Iedit_core_Button(0, this, nil);
    wrapState = new Iedit_core_Button(0, this, &Iedit_core::SetWrap);
    indentState = new Iedit_core_Button(0, this, &Iedit_core::SetIndent);
    _Shaper = new Shaper("_instance_145", 720, 650, 10000000, 10000000, 200, 100);
    Frame* _Frame_53 = new Frame("_instance_53", nil, 1);
    VBox* _VBox_49 = new VBox();
    HBox* _HBox_1 = new HBox();
    Shaper* _Shaper_2 = new Shaper("_instance_2", 255, 17, 0, 0, 14, 0);
    HBox* _HBox_3 = new HBox();
    MenuBar* _MenuBar_4 = new MenuBar();
    Iedit_core_Menu* _MenuItem_124 = new Iedit_core_Menu("_instance_124", "Open     ^O", Left, this, &Iedit_core::Open);
    Iedit_core_Menu* _MenuItem_125 = new Iedit_core_Menu("_instance_125", "New      ^N", Left, this, &Iedit_core::New);
    Iedit_core_Menu* _MenuItem_126 = new Iedit_core_Menu("_instance_126", "Save     ^S", Left, this, &Iedit_core::Save);
    Iedit_core_Menu* _MenuItem_128 = new Iedit_core_Menu("quit1", "Quit     ^Q", Left, this, &Iedit_core::Quit);
    Iedit_core_Menu* _MenuItem_127 = new Iedit_core_Menu("_instance_127", "Clear", Left, this, &Iedit_core::Clear);
    Iedit_core_Menu* _MenuItem_129 = new Iedit_core_Menu("_instance_129", "Include  ^F", Left, this, &Iedit_core::Include);
    Iedit_core_Menu* _MenuItem_130 = new Iedit_core_Menu("_instance_130", "Version", Left, this, &Iedit_core::Version);
    PulldownMenu* _PulldownMenu_5 = new PulldownMenu("fileMenu", new Message(" File", Center, 2, hfil));
    _PulldownMenu_5->Include(_MenuItem_124);
    _PulldownMenu_5->Include(_MenuItem_125);
    _PulldownMenu_5->Include(_MenuItem_126);
    _PulldownMenu_5->Include(_MenuItem_128);
    _PulldownMenu_5->Include(_MenuItem_127);
    _PulldownMenu_5->Include(_MenuItem_129);
    _PulldownMenu_5->Include(_MenuItem_130);
    Iedit_core_Menu* _MenuItem_131 = new Iedit_core_Menu("_instance_131", "Cut         ^D/Del", Left, this, &Iedit_core::Cut);
    Iedit_core_Menu* _MenuItem_132 = new Iedit_core_Menu("_instance_132", "Copy          ^Y", Left, this, &Iedit_core::Copy);
    Iedit_core_Menu* _MenuItem_133 = new Iedit_core_Menu("_instance_133", "Paste         ^P", Left, this, &Iedit_core::Paste);
    Iedit_core_Menu* _MenuItem_134 = new Iedit_core_Menu("_instance_134", "Select All", Left, this, &Iedit_core::SelectAll);
    Iedit_core_Menu* _MenuItem_148 = new Iedit_core_Menu("_instance_155", "Tab Size = 4", Left, this, &Iedit_core::TabSize_4);
    Iedit_core_Menu* _MenuItem_149 = new Iedit_core_Menu("_instance_156", "Tab Size = 8", Left, this, &Iedit_core::TabSize_8);
    Iedit_core_Menu* _MenuItem_161 = new Iedit_core_Menu("_instance_165", "You Choose", Left, this, &Iedit_core::_YouChooseTabSize);
    PullrightMenu* _PullrightMenu_143 = new PullrightMenu("_instance_150", new Message("Tab Size             ", Center, 2, hfil));
    _PullrightMenu_143->Include(_MenuItem_148);
    _PullrightMenu_143->Include(_MenuItem_149);
    _PullrightMenu_143->Include(_MenuItem_161);
    Medium12 = new Iedit_core_Menu("CourierMdeium12", "Courier Medium 12", Left, this, &Iedit_core::_CourierMedium12);
    Bold12 = new Iedit_core_Menu("CourierBold12", "Courier Bold   12", Left, this, &Iedit_core::_CourierBold12);
    Mdeium14 = new Iedit_core_Menu("CourierMedeium14", "Courier Medium 14", Left, this, &Iedit_core::_CourierMedium14);
    Bold14 = new Iedit_core_Menu("CourierBold14", "Courier Bold   14", Left, this, &Iedit_core::_CourierBold14);
    Medium18 = new Iedit_core_Menu("CourierMedium18", "Courier Medium 18", Left, this, &Iedit_core::_CourierMedium18);
    Bold18 = new Iedit_core_Menu("CourierBold18", "Courier Bold   18", Left, this, &Iedit_core::_CourierBold18);
    PullrightMenu* _PullrightMenu_145 = new PullrightMenu("_instance_152", new Message("Font                 ", Center, 2, hfil));
    _PullrightMenu_145->Include(Medium12);
    _PullrightMenu_145->Include(Bold12);
    _PullrightMenu_145->Include(Mdeium14);
    _PullrightMenu_145->Include(Bold14);
    _PullrightMenu_145->Include(Medium18);
    _PullrightMenu_145->Include(Bold18);
    PulldownMenu* _PulldownMenu_6 = new PulldownMenu("editMenu", new Message("Edit", Center, 2, hfil));
    _PulldownMenu_6->Include(_MenuItem_131);
    _PulldownMenu_6->Include(_MenuItem_132);
    _PulldownMenu_6->Include(_MenuItem_133);
    _PulldownMenu_6->Include(_MenuItem_134);
    _PulldownMenu_6->Include(_PullrightMenu_143);
    _PulldownMenu_6->Include(_PullrightMenu_145);
    Iedit_core_Menu* _MenuItem_135 = new Iedit_core_Menu("_instance_135", "Search/Replace      ^R", Left, this, &Iedit_core::Search);
    Iedit_core_Menu* _MenuItem_136 = new Iedit_core_Menu("_instance_136", "Go To Line          ^G", Left, this, &Iedit_core::GotoLine);
    Iedit_core_Menu* _MenuItem_137 = new Iedit_core_Menu("_instance_137", "Go To Selection     ^T", Left, this, &Iedit_core::GoToSelection);
    Iedit_core_Menu* _MenuItem_138 = new Iedit_core_Menu("_instance_138", "Match ()[]{}        ^B", Left, this, &Iedit_core::MatchBrackets);
    PulldownMenu* _PulldownMenu_7 = new PulldownMenu("searchMenu", new Message("Search", Center, 2, hfil));
    _PulldownMenu_7->Include(_MenuItem_135);
    _PulldownMenu_7->Include(_MenuItem_136);
    _PulldownMenu_7->Include(_MenuItem_137);
    _PulldownMenu_7->Include(_MenuItem_138);
    _MenuBar_4->Include(_PulldownMenu_5);
    _MenuBar_4->Include(_PulldownMenu_6);
    _MenuBar_4->Include(_PulldownMenu_7);
    VBorder* _VBorder_8 = new VBorder("_instance_8", 2 );
    Iedit_core_Menu* _MenuItem_9 = new Iedit_core_Menu("help", "Help", Center, this, &Iedit_core::HelpMe);
    VBorder* _VBorder_10 = new VBorder("_instance_10", 2 );
    Iedit_core_Menu* _MenuItem_11 = new Iedit_core_Menu("quit2", "Quit", Center, this, &Iedit_core::Quit);
    VBorder* _VBorder_12 = new VBorder("_instance_12", 2 );
    Iedit_core_Menu* _MenuItem_13 = new Iedit_core_Menu("save", "Save", Center, this, &Iedit_core::_Save);
    VBorder* _VBorder_14 = new VBorder("_instance_14", 2 );
    Iedit_core_Menu* _MenuItem_15 = new Iedit_core_Menu("load", "Load", Center, this, &Iedit_core::_Load);
    VBorder* _VBorder_16 = new VBorder("_instance_16", 2 );
    _HBox_3->Insert(_MenuBar_4);
    _HBox_3->Insert(_VBorder_8);
    _HBox_3->Insert(_MenuItem_9);
    _HBox_3->Insert(_VBorder_10);
    _HBox_3->Insert(_MenuItem_11);
    _HBox_3->Insert(_VBorder_12);
    _HBox_3->Insert(_MenuItem_13);
    _HBox_3->Insert(_VBorder_14);
    _HBox_3->Insert(_MenuItem_15);
    _HBox_3->Insert(_VBorder_16);
    _Shaper_2->Insert(_HBox_3);
    MarginFrame* _MarginFrame_17 = new MarginFrame("_instance_17", nil, 6, 0, 0, 1, 0, 0);
    fileName = new SelStrEditor("fileName", fileNameBS, "                                         ");
    _MarginFrame_17->Insert(fileName);
    _HBox_1->Insert(_Shaper_2);
    _HBox_1->Insert(_MarginFrame_17);
    HBorder* _HBorder_20 = new HBorder("_instance_", 2 );
    messageFrame = new HBox();
    MarginFrame* _MarginFrame_47 = new MarginFrame("_instance_47", nil, 7, 0, 0, 2, 0, 0);
    HBox* _HBox_46 = new HBox();
    CheckBox* _CheckBox_43 = new CheckBox("wrapCheckBox", "Wrap", wrapState, 1, 0);
    CheckBox* _CheckBox_44 = new CheckBox("indentCheckBox", "Indent", indentState, 1, 0);
    _HBox_46->Insert(_CheckBox_43);
    _HBox_46->Insert(_CheckBox_44);
    _MarginFrame_47->Insert(_HBox_46);
    VBorder* _VBorder_45 = new VBorder("_instance_45", 1 );
    dummyMessage = new Message("_instance_22", "dummy", Center);
    messageFrame->Insert(_MarginFrame_47);
    messageFrame->Insert(_VBorder_45);
    messageFrame->Insert(dummyMessage);
    HBorder* _HBorder_23 = new HBorder("_instance_23", 2 );
    HBox* _HBox_24 = new HBox();
    VBox* _VBox_25 = new VBox();
    MarginFrame* _MarginFrame_26 = new MarginFrame("_instance_26", nil, 2, 0, 0, 2, 0, 0);
    editor = new SelEditor("editor", 37, 60, 4, Reversed);
    editor->Edit(new TextBuffer(new char[256], 0, 256));
;
    _MarginFrame_26->Insert(editor);
    Frame* _Frame_27 = new Frame("_instance_27", nil, 2);
    HBox* _HBox_28 = new HBox();
    LeftMover* _LeftMover_29 = new LeftMover("_instance_29", editor,1);
    VBorder* _VBorder_30 = new VBorder("_instance_30", 2 );
    HScroller* _HScroller_31 = new HScroller("_instance_31", editor);
    VBorder* _VBorder_32 = new VBorder("_instance_32", 2 );
    RightMover* _RightMover_33 = new RightMover("_instance_33", editor,1);
    _HBox_28->Insert(_LeftMover_29);
    _HBox_28->Insert(_VBorder_30);
    _HBox_28->Insert(_HScroller_31);
    _HBox_28->Insert(_VBorder_32);
    _HBox_28->Insert(_RightMover_33);
    _Frame_27->Insert(_HBox_28);
    _VBox_25->Insert(_MarginFrame_26);
    _VBox_25->Insert(_Frame_27);
    VBox* _VBox_34 = new VBox();
    Frame* _Frame_35 = new Frame("_instance_35", nil, 2);
    VBox* _VBox_36 = new VBox();
    UpMover* _UpMover_37 = new UpMover("_instance_37", editor,1);
    HBorder* _HBorder_38 = new HBorder("_instance_38", 2 );
    VScroller* _VScroller_39 = new VScroller("_instance_39", editor);
    HBorder* _HBorder_40 = new HBorder("_instance_40", 2 );
    DownMover* _DownMover_41 = new DownMover("_instance_41", editor,1);
    _VBox_36->Insert(_UpMover_37);
    _VBox_36->Insert(_HBorder_38);
    _VBox_36->Insert(_VScroller_39);
    _VBox_36->Insert(_HBorder_40);
    _VBox_36->Insert(_DownMover_41);
    _Frame_35->Insert(_VBox_36);
    VGlue* _VGlue_42 = new VGlue("_instance_42", 22, 22, 22);
    _VBox_34->Insert(_Frame_35);
    _VBox_34->Insert(_VGlue_42);
    _HBox_24->Insert(_VBox_25);
    _HBox_24->Insert(_VBox_34);
    _VBox_49->Insert(_HBox_1);
    _VBox_49->Insert(_HBorder_20);
    _VBox_49->Insert(messageFrame);
    _VBox_49->Insert(_HBorder_23);
    _VBox_49->Insert(_HBox_24);
    _Frame_53->Insert(_VBox_49);
    _Shaper->Insert(_Frame_53);
    return _Shaper;
};

void Iedit_core::Open() {}
void Iedit_core::New() {}
void Iedit_core::Save() {}
void Iedit_core::Quit() {}
void Iedit_core::Clear() {}
void Iedit_core::Include() {}
void Iedit_core::Version() {}
void Iedit_core::Cut() {}
void Iedit_core::Copy() {}
void Iedit_core::Paste() {}
void Iedit_core::SelectAll() {}
void Iedit_core::TabSize_4() {}
void Iedit_core::TabSize_8() {}
void Iedit_core::_YouChooseTabSize() {}
void Iedit_core::_CourierMedium12() {}
void Iedit_core::_CourierBold12() {}
void Iedit_core::_CourierMedium14() {}
void Iedit_core::_CourierBold14() {}
void Iedit_core::_CourierMedium18() {}
void Iedit_core::_CourierBold18() {}
void Iedit_core::Search() {}
void Iedit_core::GotoLine() {}
void Iedit_core::GoToSelection() {}
void Iedit_core::MatchBrackets() {}
void Iedit_core::HelpMe() {}
void Iedit_core::_Save() {}
void Iedit_core::_Load() {}
void Iedit_core::SetWrap() {}
void Iedit_core::SetIndent() {}

