#include <InterViews/painter.h> 
#include <InterViews/shape.h> 
#include <InterViews/sensor.h> 
#include <InterViews/world.h> 
#include <InterViews/box.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/glue.h> 
#include <InterViews/message.h> 
#include <InterViews/streditor.h> 
#include "SearchDialog.h"
#include <InterViews/2.6/_enter.h>


typedef void (SearchDialog_core::*SearchDialog_core_BFunc)();

class SearchDialog_core_Button : public ButtonState {
public:
    SearchDialog_core_Button(
	int, SearchDialog_core* = nil, SearchDialog_core_BFunc = nil
    );
    virtual void Notify();
private:
    SearchDialog_core_BFunc _func;
    SearchDialog_core* _coreclass;
};

SearchDialog_core_Button::SearchDialog_core_Button(
    int i, SearchDialog_core* coreclass, SearchDialog_core_BFunc f
) : ButtonState(i) {
    _func = f;
    _coreclass = coreclass;
}

void SearchDialog_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

SearchDialog_core::SearchDialog_core (const char* name) : Dialog(
    name, nil, nil
) {
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    state = new SearchDialog_core_Button(0, this, &SearchDialog_core::searchEntered);
    Insert(Interior());
}

Interactor*SearchDialog_core::Interior() {
    searchBS = state;
    direction = new SearchDialog_core_Button(0, this, nil);
    caseBS = new SearchDialog_core_Button(0, this, nil);
    Frame* _Frame_141 = new Frame("_instance_148", nil, 1);
    MarginFrame* _MarginFrame_113 = new MarginFrame("_instance_113", nil, 34, 0, 0, 35, 0, 0);
    VBox* _VBox_99 = new VBox();
    HBox* _HBox_92 = new HBox();
    Message* _Message_55 = new Message("searchMessage", "Search For:  ", Center);
    Frame* _Frame_85 = new Frame("_instance_85", nil, 1);
    searchSE = new SelStrEditor("searchSE", searchBS, "");
    _Frame_85->Insert(searchSE);
    _HBox_92->Insert(_Message_55);
    _HBox_92->Insert(_Frame_85);
    VGlue* _VGlue_93 = new VGlue("_instance_93", 6, 6, 1000000);
    HBox* _HBox_90 = new HBox();
    Message* _Message_57 = new Message("replaceMessage", "Replace:     ", Center);
    Frame* _Frame_86 = new Frame("_instance_86", nil, 1);
    replaceSE = new SelStrEditor("replaceSE", searchBS, "");
    _Frame_86->Insert(replaceSE);
    _HBox_90->Insert(_Message_57);
    _HBox_90->Insert(_Frame_86);
    VGlue* _VGlue_94 = new VGlue("_instance_94", 6, 6, 1000000);
    HBox* _HBox_84 = new HBox();
    Message* _Message_62 = new Message("message", "Direction:", Center);
    HGlue* _HGlue_80 = new HGlue("_instance_80", 17, 17, 1000000);
    RadioButton* _RadioButton_64 = new RadioButton("button", "Forward", direction, 0);
    HGlue* _HGlue_81 = new HGlue("_instance_81", 23, 23, 1000000);
    RadioButton* _RadioButton_65 = new RadioButton("button", "Backward", direction, 1);
    HGlue* _HGlue_83 = new HGlue("_instance_83", 15, 15, 1000000);
    _HBox_84->Insert(_Message_62);
    _HBox_84->Insert(_HGlue_80);
    _HBox_84->Insert(_RadioButton_64);
    _HBox_84->Insert(_HGlue_81);
    _HBox_84->Insert(_RadioButton_65);
    _HBox_84->Insert(_HGlue_83);
    VGlue* _VGlue_95 = new VGlue("_instance_95", 4, 4, 1000000);
    HBox* _HBox_79 = new HBox();
    Message* _Message_63 = new Message("message", "Case:     ", Center);
    HGlue* _HGlue_76 = new HGlue("_instance_76", 16, 16, 1000000);
    RadioButton* _RadioButton_66 = new RadioButton("button", "Sensitive", caseBS, 0);
    HGlue* _HGlue_77 = new HGlue("_instance_77", 14, 14, 1000000);
    RadioButton* _RadioButton_67 = new RadioButton("button", "Ignored", caseBS, 1);
    HGlue* _HGlue_78 = new HGlue("_instance_78", 20, 20, 1000000);
    _HBox_79->Insert(_Message_63);
    _HBox_79->Insert(_HGlue_76);
    _HBox_79->Insert(_RadioButton_66);
    _HBox_79->Insert(_HGlue_77);
    _HBox_79->Insert(_RadioButton_67);
    _HBox_79->Insert(_HGlue_78);
    VGlue* _VGlue_96 = new VGlue("_instance_96", 10, 10, 1000000);
    HBox* _HBox_74 = new HBox();
    HGlue* _HGlue_71 = new HGlue("_instance_71", 27, 27, 1000000);
    PushButton* _PushButton_68 = new PushButton("button", "Replace", searchBS, 3);
    HGlue* _HGlue_72 = new HGlue("_instance_72", 13, 13, 1000000);
    PushButton* _PushButton_69 = new PushButton("button", "Cancel", searchBS, 2);
    HGlue* _HGlue_73 = new HGlue("_instance_73", 9, 9, 1000000);
    PushButton* _PushButton_70 = new PushButton("button", "Search", searchBS, 1);
    _HBox_74->Insert(_HGlue_71);
    _HBox_74->Insert(_PushButton_68);
    _HBox_74->Insert(_HGlue_72);
    _HBox_74->Insert(_PushButton_69);
    _HBox_74->Insert(_HGlue_73);
    _HBox_74->Insert(_PushButton_70);
    _VBox_99->Insert(_HBox_92);
    _VBox_99->Insert(_VGlue_93);
    _VBox_99->Insert(_HBox_90);
    _VBox_99->Insert(_VGlue_94);
    _VBox_99->Insert(_HBox_84);
    _VBox_99->Insert(_VGlue_95);
    _VBox_99->Insert(_HBox_79);
    _VBox_99->Insert(_VGlue_96);
    _VBox_99->Insert(_HBox_74);
    _MarginFrame_113->Insert(_VBox_99);
    _Frame_141->Insert(_MarginFrame_113);
    return _Frame_141;
};

void SearchDialog_core::searchEntered() {}

