/*
 * Copyright (c) 1987, 1988, 1989, 1990, 1991 Stanford University
 * Copyright (c) 1991 Silicon Graphics, Inc.
 * Copyright (c) 1991 Yufan Hu (yufan@cs.keele.ac.uk)
 *		Dept. of Computer Science, University of Keele, UK
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Stanford and Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Stanford and Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL STANFORD OR SILICON GRAPHICS OR KEELE UNIVERSITY OR
 * Yufan Hu BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL 
 * DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, 
 * AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE 
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <InterViews/button.h>
#include <InterViews/streditor.h>
#include "SearchDialog.h"
#include <InterViews/2.6/_enter.h>

SearchDialog::SearchDialog(const char* name) : SearchDialog_core(name) {}

boolean SearchDialog::ForwardSearch(){
	int value;
	direction->GetValue(value);
	return value == 0;
}

boolean SearchDialog::CaseIgnored(){
	int value;
	caseBS->GetValue(value);
	return value == 1;
}

boolean SearchDialog::IsReplace(){
	int value;
	searchBS->GetValue(value);
	return value == 3;
}

boolean SearchDialog::Accept(){
	int value = 0;
	SearchDialog_core::Accept();
	searchBS->GetValue(value);
	return value == 1 || value == 3;
}

void SearchDialog::searchEntered(){
	int value;
	searchBS->GetValue(value);
	if(value > 3) searchBS->SetValue(1);
}

