#ifndef _KEY4CODE_YUFAN
#define _KEY4CODE_YUFAN

/*
 * Copyright (c) 1987, 1988, 1989, 1990, 1991 Stanford University
 * Copyright (c) 1991 Silicon Graphics, Inc.
 * Copyright (c) 1991 Yufan Hu (yufan@cs.keele.ac.uk)
 *		Dept. of Computer Science, University of Keele, UK
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Stanford and Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Stanford and Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL STANFORD OR SILICON GRAPHICS OR KEELE UNIVERSITY OR
 * Yufan Hu BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL 
 * DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, 
 * AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE 
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/*
	Definition of Sun4 type 4 keyboard code
	Only for special keys
*/

#define Ctrl(c)	((c) - '@')

static const unsigned char KeyR1 = 0x1c;
static const unsigned char KeyR2 = 0x1d;
static const unsigned char KeyR3 = 0x1e;
static const unsigned char KeyR4 = 0x34;
static const unsigned char KeyR5 = 0x35;
static const unsigned char KeyR6 = 0x36;
static const unsigned char KeyR7 = 0x4b;
static const unsigned char KeyR8 = 0x4c;
static const unsigned char KeyR9 = 0x4d;
static const unsigned char KeyR10 = 0x62;
static const unsigned char KeyR11 = 0x63;
static const unsigned char KeyR12 = 0x64;
static const unsigned char KeyR13 = 0x77;
static const unsigned char KeyR14 = 0x78;
static const unsigned char KeyR15 = 0x79;
static const unsigned char KeyIns = 0x65;

#define KeyUpArraw		KeyR8
#define KeyDownArraw	KeyR14
#define KeyLeftArraw	KeyR10
#define KeyRightArraw	KeyR12
#define KeyHome			KeyR7
#define KeyEnd			KeyR13
#define KeyPageUp		KeyR9
#define KeyPageDown		KeyR15

static const unsigned char KeyL1 = 0x8;
static const unsigned char KeyL2 = 0xa;
static const unsigned char KeyL3 = 0x20;
static const unsigned char KeyL4 = 0x21;
static const unsigned char KeyL5 = 0x38;
static const unsigned char KeyL6 = 0x3a;
static const unsigned char KeyL7 = 0x4f;
static const unsigned char KeyL8 = 0x50;
static const unsigned char KeyL9 = 0x66;
static const unsigned char KeyL10 = 0x68;
static const unsigned char KeyHelp = 0x7d;

#define KeyStop		KeyL1
#define KeyAgain	KeyL2
#define KeyProps	KeyL3
#define KeyUndo		KeyL4
#define KeyFront	KeyL5
#define KeyCopy		KeyL6
#define KeyOpen		KeyL7
#define KeyPaste	KeyL8
#define KeyFind		KeyL9
#define KeyCut		KeyL10

static const unsigned char KeyF1 = 0x0c;
static const unsigned char KeyF2 = 0x0d;
static const unsigned char KeyF3 = 0x0f;
static const unsigned char KeyF4 = 0x11;
static const unsigned char KeyF5 = 0x13;
static const unsigned char KeyF6 = 0x15;
static const unsigned char KeyF7 = 0x17;
static const unsigned char KeyF8 = 0x18;
static const unsigned char KeyF9 = 0x19;
static const unsigned char KeyF10 = 0x0e;
static const unsigned char KeyF11 = 0x10;
static const unsigned char KeyF12 = 0x12;

#endif 