#include <InterViews/canvas.h> 
#include <InterViews/painter.h> 
#include <InterViews/sensor.h> 
#include <InterViews/perspective.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/box.h> 
#include <InterViews/message.h> 
#include <InterViews/glue.h> 
#include <InterViews/filebrowser.h> 
#include <InterViews/border.h> 
#include <InterViews/adjuster.h> 
#include <InterViews/scroller.h> 
#include "OpenDialog-core.h" 
#include <IV-2_6/_enter.h>


#ifndef OpenDialog_core_func
#define OpenDialog_core_func
typedef void (OpenDialog_core::*OpenDialog_core_Func)();
#endif

class OpenDialog_core_Button : public ButtonState {
public:
    OpenDialog_core_Button(int, OpenDialog_core* = nil, OpenDialog_core_Func = nil);
    virtual void Notify();
    void SetCoreClass(OpenDialog_core*);
    void SetCoreFunc(OpenDialog_core_Func);
private:
    OpenDialog_core_Func _func;
    OpenDialog_core* _coreclass;
};

OpenDialog_core_Button::OpenDialog_core_Button(
    int i, OpenDialog_core* coreclass, OpenDialog_core_Func func
) : ButtonState(i) {
    _coreclass = coreclass;
    _func = func;
}

void OpenDialog_core_Button::SetCoreClass(OpenDialog_core* core) {
    _coreclass = core;
}

void OpenDialog_core_Button::SetCoreFunc(OpenDialog_core_Func func) {
    _func = func;
}

void OpenDialog_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

class OpenDialog_core_HGlue : public HGlue {
public:
    OpenDialog_core_HGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

class OpenDialog_core_VGlue : public VGlue {
public:
    OpenDialog_core_VGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

OpenDialog_core_HGlue::OpenDialog_core_HGlue (
    const char* name, int nat, int shr, int str) : HGlue(name, nat, shr, str) {}

void OpenDialog_core_HGlue::Resize () {
    HGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

OpenDialog_core_VGlue::OpenDialog_core_VGlue (
    const char* name, int nat, int shr, int str) : VGlue(name, nat, shr, str) {}

void OpenDialog_core_VGlue::Resize () {
    VGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

OpenDialog_core::OpenDialog_core (const char* name) : Dialog(
    name, nil, nil
) {
    SetClassName("OpenDialog");
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    state = new OpenDialog_core_Button(0, this, nil);
    Insert(Interior());
}

Interactor*OpenDialog_core::Interior() {
    ButtonState* _BS_2 = state;
    ShadowFrame* _ShadowFrame_147 = new ShadowFrame("_instance_136", nil, 1, 1);
    MarginFrame* _MarginFrame_142 = new MarginFrame("_instance_131", nil, 13, 1000000, 1000000, 19, 1000000, 1000000);
    VBox* _VBox_141 = new VBox();
    Message* _Message_128 = new Message("_instance_117", "Choose a file to open:", Center, 0, 0, 0);
    VGlue* _VGlue_139 = new OpenDialog_core_VGlue("_instance_128", 10, 0, 0);
    Frame* _Frame_127 = new Frame("_instance_116", nil, 1);
    HBox* _HBox_126 = new HBox();
    MarginFrame* _MarginFrame_144 = new MarginFrame("_instance_133", nil, 1, 0, 0, 1, 0, 0);
    openFB = new FileBrowser("_instance_106", _BS_2, "./", 11, 18, true);
    _MarginFrame_144->Insert(openFB);
    VBorder* _VBorder_125 = new VBorder("_instance_114", 1 );
    VBox* _VBox_119 = new VBox();
    UpMover* _UpMover_120 = new UpMover("_instance_109", openFB, 1);
    HBorder* _HBorder_121 = new HBorder("_instance_110", 2 );
    VScroller* _VScroller_122 = new VScroller("_instance_111", openFB);
    HBorder* _HBorder_123 = new HBorder("_instance_112", 2 );
    DownMover* _DownMover_124 = new DownMover("_instance_113", openFB, 1);
    _VBox_119->Insert(_UpMover_120);
    _VBox_119->Insert(_HBorder_121);
    _VBox_119->Insert(_VScroller_122);
    _VBox_119->Insert(_HBorder_123);
    _VBox_119->Insert(_DownMover_124);
    _HBox_126->Insert(_MarginFrame_144);
    _HBox_126->Insert(_VBorder_125);
    _HBox_126->Insert(_VBox_119);
    _Frame_127->Insert(_HBox_126);
    VGlue* _VGlue_140 = new OpenDialog_core_VGlue("_instance_129", 10, 0, 0);
    HBox* _HBox_136 = new HBox();
    HGlue* _HGlue_134 = new OpenDialog_core_HGlue("_instance_123", 62, 62, 1000000);
    PushButton* _PushButton_132 = new PushButton("_instance_121", " Cancel ", _BS_2, 2);
    HGlue* _HGlue_135 = new OpenDialog_core_HGlue("_instance_124", 20, 0, 0);
    PushButton* _PushButton_133 = new PushButton("_instance_122", "  OK  ", _BS_2, 1);
    _HBox_136->Insert(_HGlue_134);
    _HBox_136->Insert(_PushButton_132);
    _HBox_136->Insert(_HGlue_135);
    _HBox_136->Insert(_PushButton_133);
    _VBox_141->Insert(_Message_128);
    _VBox_141->Insert(_VGlue_139);
    _VBox_141->Insert(_Frame_127);
    _VBox_141->Insert(_VGlue_140);
    _VBox_141->Insert(_HBox_136);
    _MarginFrame_142->Insert(_VBox_141);
    _ShadowFrame_147->Insert(_MarginFrame_142);
    return _ShadowFrame_147;
};


