#ifndef RadioButton_h
#define RadioButton_h

static char _rcs_id_RadioButton_h[] = "DATAP $Source: /usr/datap/include/Iv/RCS/RadioButton.h,v $ $Revision: 1.4 $";

// Copyright (c) DATAP Systems, 1991. All rights reserved.
// License material - Property of DATAP Systems.
//
// Project: 987050 C 440
// Library: Iv
// File: RadioButton.cc

/*
 * Revision History:
 *   $Log: RadioButton.h,v $
 * Revision 1.4  1991/10/31  23:20:57  pbrown
 * Resolved action items for inspection #202
 *
 * Revision 1.3  1991/10/17  19:42:23  pbrown
 * Pre-inspection cleanup.
 *
 * Revision 1.2  1991/10/11  15:18:06  dmorriso
 * Minor changes to comply with IV 3.0 update.
 *
 * Revision 1.1  1991/07/15  20:09:30  morrison
 * Initial revision
 *
 */

// Section: Description
//   This subclass of ToggleButton is designed to fit into a set of
//   buttons where the choosing of one unchooses the previously chosen
//   one.  This behaviour is typical of the old-fashioned, car radio-buttons.
//   radio button is added to the 'box'.  In addition a chosen button
//   cannot be directly unchosen; it can only be done by choosing another
//   button.

// Section: Usage Hints
//   A RadioButtonSet instance must be created before the construction of
//   a RadioButton.  The button set provides the mechanism that links
//   the group of radio buttons together.

#include <Iv/ToggleButton.h>

class RadioButtonSet;

class RadioButton: public ToggleButton
{
public:
    RadioButton(Action* anAction, Telltale* telltale, RadioButtonSet* buttonSet);
    virtual ~RadioButton();
    virtual void drag(Event& anEvent);
    virtual void release(Event& anEvent);
    virtual void commit(Event& anEvent);
    virtual void choose(boolean state);

private:
    RadioButtonSet* _buttonSet;
    void informButtonSet();
};

#endif /* RadioButton_h */
