#include <InterViews/canvas.h> 
#include <InterViews/painter.h> 
#include <InterViews/sensor.h> 
#include <InterViews/perspective.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/box.h> 
#include <InterViews/message.h> 
#include <InterViews/glue.h> 
#include <InterViews/streditor.h> 
#include <InterViews/filebrowser.h> 
#include <InterViews/border.h> 
#include <InterViews/adjuster.h> 
#include <InterViews/scroller.h> 
#include "SaveDialog-core.h" 
#include <IV-2_6/_enter.h>


#ifndef SaveDialog_core_func
#define SaveDialog_core_func
typedef void (SaveDialog_core::*SaveDialog_core_Func)();
#endif

class SaveDialog_core_Button : public ButtonState {
public:
    SaveDialog_core_Button(int, SaveDialog_core* = nil, SaveDialog_core_Func = nil);
    virtual void Notify();
    void SetCoreClass(SaveDialog_core*);
    void SetCoreFunc(SaveDialog_core_Func);
private:
    SaveDialog_core_Func _func;
    SaveDialog_core* _coreclass;
};

SaveDialog_core_Button::SaveDialog_core_Button(
    int i, SaveDialog_core* coreclass, SaveDialog_core_Func func
) : ButtonState(i) {
    _coreclass = coreclass;
    _func = func;
}

void SaveDialog_core_Button::SetCoreClass(SaveDialog_core* core) {
    _coreclass = core;
}

void SaveDialog_core_Button::SetCoreFunc(SaveDialog_core_Func func) {
    _func = func;
}

void SaveDialog_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

class SaveDialog_core_HGlue : public HGlue {
public:
    SaveDialog_core_HGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

class SaveDialog_core_VGlue : public VGlue {
public:
    SaveDialog_core_VGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

SaveDialog_core_HGlue::SaveDialog_core_HGlue (
    const char* name, int nat, int shr, int str) : HGlue(name, nat, shr, str) {}

void SaveDialog_core_HGlue::Resize () {
    HGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

SaveDialog_core_VGlue::SaveDialog_core_VGlue (
    const char* name, int nat, int shr, int str) : VGlue(name, nat, shr, str) {}

void SaveDialog_core_VGlue::Resize () {
    VGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

SaveDialog_core::SaveDialog_core (const char* name) : Dialog(
    name, nil, nil
) {
    SetClassName("SaveDialog");
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    state = new SaveDialog_core_Button(0, this, nil);
    Insert(Interior());
}

Interactor*SaveDialog_core::Interior() {
    ButtonState* _BS_1 = state;
    ShadowFrame* _ShadowFrame_147 = new ShadowFrame("_instance_136", nil, 1, 1);
    MarginFrame* _MarginFrame_142 = new MarginFrame("_instance_131", nil, 13, 1000000, 1000000, 19, 1000000, 1000000);
    VBox* _VBox_141 = new VBox();
    Message* _Message_128 = new Message("_instance_117", "Save this file as:", Center, 0, 0, 0);
    VGlue* _VGlue_138 = new SaveDialog_core_VGlue("_instance_127", 10, 0, 0);
    Frame* _Frame_131 = new Frame("_instance_120", nil, 1);
    MarginFrame* _MarginFrame_143 = new MarginFrame("_instance_132", nil, 1, 0, 0, 1, 0, 0);
    saveSE = new StringEditor("_instance_118", _BS_1, "asdfasdf");
    saveSE->Message("");
    _MarginFrame_143->Insert(saveSE);
    _Frame_131->Insert(_MarginFrame_143);
    VGlue* _VGlue_139 = new SaveDialog_core_VGlue("_instance_128", 10, 0, 0);
    Frame* _Frame_127 = new Frame("_instance_116", nil, 1);
    HBox* _HBox_126 = new HBox();
    MarginFrame* _MarginFrame_144 = new MarginFrame("_instance_133", nil, 1, 0, 0, 1, 0, 0);
    FileBrowser* _FileBrowser_117 = new FileBrowser("_instance_106", _BS_1, "./", 11, 18, true);
    _MarginFrame_144->Insert(_FileBrowser_117);
    VBorder* _VBorder_125 = new VBorder("_instance_114", 1 );
    VBox* _VBox_119 = new VBox();
    UpMover* _UpMover_120 = new UpMover("_instance_109", _FileBrowser_117, 1);
    HBorder* _HBorder_121 = new HBorder("_instance_110", 2 );
    VScroller* _VScroller_122 = new VScroller("_instance_111", _FileBrowser_117);
    HBorder* _HBorder_123 = new HBorder("_instance_112", 2 );
    DownMover* _DownMover_124 = new DownMover("_instance_113", _FileBrowser_117, 1);
    _VBox_119->Insert(_UpMover_120);
    _VBox_119->Insert(_HBorder_121);
    _VBox_119->Insert(_VScroller_122);
    _VBox_119->Insert(_HBorder_123);
    _VBox_119->Insert(_DownMover_124);
    _HBox_126->Insert(_MarginFrame_144);
    _HBox_126->Insert(_VBorder_125);
    _HBox_126->Insert(_VBox_119);
    _Frame_127->Insert(_HBox_126);
    VGlue* _VGlue_140 = new SaveDialog_core_VGlue("_instance_129", 10, 0, 0);
    HBox* _HBox_136 = new HBox();
    HGlue* _HGlue_134 = new SaveDialog_core_HGlue("_instance_123", 62, 62, 1000000);
    PushButton* _PushButton_132 = new PushButton("_instance_121", " Cancel ", _BS_1, 2);
    HGlue* _HGlue_135 = new SaveDialog_core_HGlue("_instance_124", 20, 0, 0);
    PushButton* _PushButton_133 = new PushButton("_instance_122", "  OK  ", _BS_1, 1);
    _HBox_136->Insert(_HGlue_134);
    _HBox_136->Insert(_PushButton_132);
    _HBox_136->Insert(_HGlue_135);
    _HBox_136->Insert(_PushButton_133);
    _VBox_141->Insert(_Message_128);
    _VBox_141->Insert(_VGlue_138);
    _VBox_141->Insert(_Frame_131);
    _VBox_141->Insert(_VGlue_139);
    _VBox_141->Insert(_Frame_127);
    _VBox_141->Insert(_VGlue_140);
    _VBox_141->Insert(_HBox_136);
    _MarginFrame_142->Insert(_VBox_141);
    _ShadowFrame_147->Insert(_MarginFrame_142);
    return _ShadowFrame_147;
};


