#include <InterViews/canvas.h> 
#include <InterViews/painter.h> 
#include <InterViews/sensor.h> 
#include <InterViews/perspective.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/box.h> 
#include <InterViews/message.h> 
#include <InterViews/glue.h> 
#include <InterViews/streditor.h> 
#include "SearchDialog-core.h" 
#include <IV-2_6/_enter.h>


#ifndef SearchDialog_core_func
#define SearchDialog_core_func
typedef void (SearchDialog_core::*SearchDialog_core_Func)();
#endif

class SearchDialog_core_Button : public ButtonState {
public:
    SearchDialog_core_Button(int, SearchDialog_core* = nil, SearchDialog_core_Func = nil);
    virtual void Notify();
    void SetCoreClass(SearchDialog_core*);
    void SetCoreFunc(SearchDialog_core_Func);
private:
    SearchDialog_core_Func _func;
    SearchDialog_core* _coreclass;
};

SearchDialog_core_Button::SearchDialog_core_Button(
    int i, SearchDialog_core* coreclass, SearchDialog_core_Func func
) : ButtonState(i) {
    _coreclass = coreclass;
    _func = func;
}

void SearchDialog_core_Button::SetCoreClass(SearchDialog_core* core) {
    _coreclass = core;
}

void SearchDialog_core_Button::SetCoreFunc(SearchDialog_core_Func func) {
    _func = func;
}

void SearchDialog_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

class SearchDialog_core_HGlue : public HGlue {
public:
    SearchDialog_core_HGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

class SearchDialog_core_VGlue : public VGlue {
public:
    SearchDialog_core_VGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

SearchDialog_core_HGlue::SearchDialog_core_HGlue (
    const char* name, int nat, int shr, int str) : HGlue(name, nat, shr, str) {}

void SearchDialog_core_HGlue::Resize () {
    HGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

SearchDialog_core_VGlue::SearchDialog_core_VGlue (
    const char* name, int nat, int shr, int str) : VGlue(name, nat, shr, str) {}

void SearchDialog_core_VGlue::Resize () {
    VGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

SearchDialog_core::SearchDialog_core (const char* name) : Dialog(
    name, nil, nil
) {
    SetClassName("SearchDialog");
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    state = new SearchDialog_core_Button(0, this, nil);
    Insert(Interior());
}

Interactor*SearchDialog_core::Interior() {
    ButtonState* _BS_3 = state;
    ShadowFrame* _ShadowFrame_147 = new ShadowFrame("_instance_136", nil, 1, 1);
    MarginFrame* _MarginFrame_142 = new MarginFrame("_instance_131", nil, 13, 1000000, 1000000, 19, 1000000, 1000000);
    VBox* _VBox_141 = new VBox();
    Message* _Message_128 = new Message("_instance_117", "Search for:", Center, 0, 0, 0);
    VGlue* _VGlue_138 = new SearchDialog_core_VGlue("_instance_127", 10, 0, 0);
    Frame* _Frame_131 = new Frame("_instance_120", nil, 1);
    MarginFrame* _MarginFrame_143 = new MarginFrame("_instance_132", nil, 1, 0, 0, 1, 0, 0);
    searchSE = new StringEditor("_instance_118", _BS_3, "");
    searchSE->Message("");
    _MarginFrame_143->Insert(searchSE);
    _Frame_131->Insert(_MarginFrame_143);
    VGlue* _VGlue_139 = new SearchDialog_core_VGlue("_instance_128", 10, 0, 0);
    HBox* _HBox_136 = new HBox();
    HGlue* _HGlue_177 = new SearchDialog_core_HGlue("_instance_166", 163, 163, 1000000);
    PushButton* _PushButton_132 = new PushButton("_instance_121", " Cancel ", _BS_3, 2);
    HGlue* _HGlue_135 = new SearchDialog_core_HGlue("_instance_124", 20, 0, 0);
    PushButton* _PushButton_133 = new PushButton("_instance_122", "  OK  ", _BS_3, 1);
    _HBox_136->Insert(_HGlue_177);
    _HBox_136->Insert(_PushButton_132);
    _HBox_136->Insert(_HGlue_135);
    _HBox_136->Insert(_PushButton_133);
    _VBox_141->Insert(_Message_128);
    _VBox_141->Insert(_VGlue_138);
    _VBox_141->Insert(_Frame_131);
    _VBox_141->Insert(_VGlue_139);
    _VBox_141->Insert(_HBox_136);
    _MarginFrame_142->Insert(_VBox_141);
    _ShadowFrame_147->Insert(_MarginFrame_142);
    return _ShadowFrame_147;
};


