#include <InterViews/canvas.h> 
#include <InterViews/painter.h> 
#include <InterViews/sensor.h> 
#include <InterViews/perspective.h> 
#include <InterViews/box.h> 
#include <InterViews/menu.h> 
#include <InterViews/message.h> 
#include <InterViews/glue.h> 
#include <InterViews/border.h> 
#include <InterViews/frame.h> 
#include <InterViews/texteditor.h> 
#include <InterViews/textbuffer.h> 
#include <InterViews/adjuster.h> 
#include <InterViews/scroller.h> 
#include "Sted-core.h" 
#include <IV-2_6/_enter.h>


class Sted_core_HGlue : public HGlue {
public:
    Sted_core_HGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

class Sted_core_VGlue : public VGlue {
public:
    Sted_core_VGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

Sted_core_HGlue::Sted_core_HGlue (
    const char* name, int nat, int shr, int str) : HGlue(name, nat, shr, str) {}

void Sted_core_HGlue::Resize () {
    HGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

Sted_core_VGlue::Sted_core_VGlue (
    const char* name, int nat, int shr, int str) : VGlue(name, nat, shr, str) {}

void Sted_core_VGlue::Resize () {
    VGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

#ifndef Sted_core_func
#define Sted_core_func
typedef void (Sted_core::*Sted_core_Func)();
#endif

class Sted_core_Menu : public MenuItem {
public:
    Sted_core_Menu(const char*, Interactor*);
    virtual void Do();
    void SetCoreClass(Sted_core*);
    void SetCoreFunc(Sted_core_Func);
private:
    Sted_core_Func _func;
    Sted_core* _coreclass;
};

Sted_core_Menu::Sted_core_Menu(
    const char* instance, Interactor* i
) : MenuItem(instance, i) {
    _func = nil;
    _coreclass = nil;
}

void Sted_core_Menu::SetCoreClass(Sted_core* core) {
    _coreclass = core;
}

void Sted_core_Menu::SetCoreFunc(Sted_core_Func func) {
    _func = func;
}

void Sted_core_Menu::Do() {
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

Sted_core::Sted_core(const char* name) {
    SetClassName("Sted");
    SetInstance(name);
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    Insert(Interior());
}

Interactor* Sted_core::Interior() {
    VBox* _VBox_73 = new VBox();
    HBox* _HBox_71 = new HBox();
    MenuBar* _MenuBar_70 = new MenuBar("_instance_59");
    Sted_core_Menu* _MenuItem_76 = new Sted_core_Menu("_instance_65", new Message("New", Left, 2, 1000000, 0));
    _MenuItem_76->SetCoreClass(this);
    _MenuItem_76->SetCoreFunc(&Sted_core::New);
    Sted_core_Menu* _MenuItem_77 = new Sted_core_Menu("_instance_66", new Message("Open...", Left, 2, 1000000, 0));
    _MenuItem_77->SetCoreClass(this);
    _MenuItem_77->SetCoreFunc(&Sted_core::Open);
    Sted_core_Menu* _MenuItem_78 = new Sted_core_Menu("_instance_67", new Message("Save...", Left, 2, 1000000, 0));
    _MenuItem_78->SetCoreClass(this);
    _MenuItem_78->SetCoreFunc(&Sted_core::Save);
    VBox* _VBox_85 = new VBox();
    VGlue* _VGlue_86 = new Sted_core_VGlue("_instance_75", 6, 0, 0);
    HBorder* _HBorder_87 = new HBorder("_instance_76", 1 );
    VGlue* _VGlue_88 = new Sted_core_VGlue("_instance_77", 6, 0, 0);
    _VBox_85->Insert(_VGlue_86);
    _VBox_85->Insert(_HBorder_87);
    _VBox_85->Insert(_VGlue_88);
    Sted_core_Menu* _MenuItem_79 = new Sted_core_Menu("_instance_68", new Message("Quit", Left, 2, 1000000, 0));
    _MenuItem_79->SetCoreClass(this);
    _MenuItem_79->SetCoreFunc(&Sted_core::Quit);
    PulldownMenu* _PulldownMenu_63 = new PulldownMenu("_instance_52", new Message(" File ", Center, 2, 0, 0));
    _PulldownMenu_63->Include(_MenuItem_76);
    _PulldownMenu_63->Include(_MenuItem_77);
    _PulldownMenu_63->Include(_MenuItem_78);
    _PulldownMenu_63->GetScene()->Insert(_VBox_85);
    _PulldownMenu_63->Include(_MenuItem_79);
    Sted_core_Menu* _MenuItem_89 = new Sted_core_Menu("_instance_78", new Message("Cut", Left, 2, 1000000, 0));
    _MenuItem_89->SetCoreClass(this);
    _MenuItem_89->SetCoreFunc(&Sted_core::Cut);
    Sted_core_Menu* _MenuItem_90 = new Sted_core_Menu("_instance_79", new Message("Copy", Left, 2, 1000000, 0));
    _MenuItem_90->SetCoreClass(this);
    _MenuItem_90->SetCoreFunc(&Sted_core::Copy);
    Sted_core_Menu* _MenuItem_91 = new Sted_core_Menu("_instance_80", new Message("Paste", Left, 2, 1000000, 0));
    _MenuItem_91->SetCoreClass(this);
    _MenuItem_91->SetCoreFunc(&Sted_core::Paste);
    PulldownMenu* _PulldownMenu_65 = new PulldownMenu("_instance_54", new Message(" Edit ", Center, 2, 0, 0));
    _PulldownMenu_65->Include(_MenuItem_89);
    _PulldownMenu_65->Include(_MenuItem_90);
    _PulldownMenu_65->Include(_MenuItem_91);
    Sted_core_Menu* _MenuItem_92 = new Sted_core_Menu("_instance_81", new Message("Search...", Left, 2, 1000000, 0));
    _MenuItem_92->SetCoreClass(this);
    _MenuItem_92->SetCoreFunc(&Sted_core::Search);
    PulldownMenu* _PulldownMenu_67 = new PulldownMenu("_instance_56", new Message(" Search ", Center, 2, 0, 0));
    _PulldownMenu_67->Include(_MenuItem_92);
    _MenuBar_70->Include(_PulldownMenu_63);
    _MenuBar_70->Include(_PulldownMenu_65);
    _MenuBar_70->Include(_PulldownMenu_67);
    HGlue* _HGlue_69 = new Sted_core_HGlue("_instance_58", 68, 68, 100000000);
    _HBox_71->Insert(_MenuBar_70);
    _HBox_71->Insert(_HGlue_69);
    HBorder* _HBorder_72 = new HBorder("_instance_61", 1 );
    VBox* _VBox_62 = new VBox();
    HBox* _HBox_61 = new HBox();
    MarginFrame* _MarginFrame_145 = new MarginFrame("_instance_134", nil, 1, 0, 0, 1, 0, 0);
    editor = new TextEditor("_instance_31", 17, 38, 4, Reversed);
    editor->Edit(new TextBuffer(new char[256], 0, 256));
    _MarginFrame_145->Insert(editor);
    VBorder* _VBorder_44 = new VBorder("_instance_33", 1 );
    VBox* _VBox_45 = new VBox();
    UpMover* _UpMover_46 = new UpMover("_instance_35", editor, 1);
    HBorder* _HBorder_47 = new HBorder("_instance_36", 2 );
    VScroller* _VScroller_48 = new VScroller("_instance_37", editor);
    HBorder* _HBorder_49 = new HBorder("_instance_38", 2 );
    DownMover* _DownMover_50 = new DownMover("_instance_39", editor, 1);
    _VBox_45->Insert(_UpMover_46);
    _VBox_45->Insert(_HBorder_47);
    _VBox_45->Insert(_VScroller_48);
    _VBox_45->Insert(_HBorder_49);
    _VBox_45->Insert(_DownMover_50);
    _HBox_61->Insert(_MarginFrame_145);
    _HBox_61->Insert(_VBorder_44);
    _HBox_61->Insert(_VBox_45);
    HBorder* _HBorder_57 = new HBorder("_instance_46", 1 );
    HBox* _HBox_60 = new HBox();
    HBox* _HBox_51 = new HBox();
    LeftMover* _LeftMover_52 = new LeftMover("_instance_41", editor, 1);
    VBorder* _VBorder_53 = new VBorder("_instance_42", 2 );
    HScroller* _HScroller_54 = new HScroller("_instance_43", editor);
    VBorder* _VBorder_55 = new VBorder("_instance_44", 2 );
    RightMover* _RightMover_56 = new RightMover("_instance_45", editor, 1);
    _HBox_51->Insert(_LeftMover_52);
    _HBox_51->Insert(_VBorder_53);
    _HBox_51->Insert(_HScroller_54);
    _HBox_51->Insert(_VBorder_55);
    _HBox_51->Insert(_RightMover_56);
    VBorder* _VBorder_59 = new VBorder("_instance_48", 1 );
    HGlue* _HGlue_58 = new Sted_core_HGlue("_instance_47", 18, 0, 0);
    _HBox_60->Insert(_HBox_51);
    _HBox_60->Insert(_VBorder_59);
    _HBox_60->Insert(_HGlue_58);
    _VBox_62->Insert(_HBox_61);
    _VBox_62->Insert(_HBorder_57);
    _VBox_62->Insert(_HBox_60);
    _VBox_73->Insert(_HBox_71);
    _VBox_73->Insert(_HBorder_72);
    _VBox_73->Insert(_VBox_62);
    return _VBox_73;
};

void Sted_core::New() {}
void Sted_core::Open() {}
void Sted_core::Save() {}
void Sted_core::Quit() {}
void Sted_core::Cut() {}
void Sted_core::Copy() {}
void Sted_core::Paste() {}
void Sted_core::Search() {}

