/*  A CheckItem is a CommandItem that has a check next to it that	*
 *  can be checked and unchecked.					*
 *									*
 *  By Greg Brail. Copyright 1990 Brown University.			*/

#ifndef CHECKITEM_H
#define CHECKITEM_H

#include "commanditem.h"
#include "check.xbm"

class Bitmap;

class CheckState : public Subject

{
private:
  boolean value;
public:
  CheckState(boolean initVal = false);			// Constructor
  boolean GetValue()					// Return value of check
    {
      return value;
    }
  void SetValue(boolean newVal);			// Set check value
};

class CheckItem : public CommandItem

{
private:
  Bitmap* checkIcon;					// Check sign
  CheckState* state;					// State it depends on
  boolean value;
public:
  CheckItem(const char* name, Command menuFunction, 	// Constructor
	    void* what, char* key = "",
	    CheckState* s = nil);
  virtual ~CheckItem();
  virtual void Do();						// When item is picked
  virtual void Update();					// Update when state changes
  virtual void Reconfig();
  virtual void Redraw(Coord l, Coord b, Coord r, Coord t);
};
	
#endif
