/*  $Id: commanditem.C,v 1.2 90/06/17 18:45:17 gjb Exp $
 *  Implementations for CommandItems.				*
 *								*
 *  By Greg Brail. Copyright 1990 Brown University.		*/

#include <InterViews/message.h>
#include "commanditem.h"
#include <stdio.h>
#include <string.h>
#include <InterViews/glue.h>
#include <InterViews/interactor.h>
#include <InterViews/event.h>
#include <InterViews/sensor.h>
#include <InterViews/painter.h>
#include <InterViews/color.h>
#include <InterViews/canvas.h>
#include <InterViews/shape.h>
#include <InterViews/font.h>
#include <InterViews/world.h>
#include <InterViews/banner.h>
#include <InterViews/frame.h>

CommandItem::CommandItem(const char* name,		// name of menu item
			 Command menuFunction,   	// Function to call
			 void* what,			// What object to call from
			 char* key)			// Optional keyboard key
     : (name, key)

{
  whatFunction = menuFunction;
  whatObject = what;
}

CommandItem::~CommandItem()

{
  /* Do nothing */
}

void CommandItem::Reconfig()

{
  ThreeDMenuItem::Reconfig();
  SetClassName("CommandItem");
}

void CommandItem::Handle(Event& e)

{
  if (enabled)
    {
      switch(e.eventType)
	{
	case DownEvent:
	  Down();
	  break;
	case UpEvent:
	  Up();
	      break;
	case EnterEvent:
	  Enter();
	  break;
	case LeaveEvent:
	  Leave();
	  break;
	}
    }
}

void CommandItem::Wait(int sec, int usec) 	// Pause in seconds and useconds

{
  Event anEvent;
  
  input->CatchTimer(sec, usec);
  do
    {
      Read(anEvent);
    }
  while (anEvent.eventType != TimerEvent);
}

void CommandItem::Do()

{
  if (whatFunction != NULL)
    (*whatFunction)(whatObject);
}
      
