/* $Id: commanditem.h,v 1.2 90/06/17 18:45:19 gjb Exp $
 * A CommandItem is a subclass of TextItem (which is a subclass		*
 * of MenuItem) which calls a function when selected. 			*
 *									*
 *  By Greg Brail. Copyright 1990 Brown University.			*/

#ifndef COMMANDITEM_H
#define COMMANDITEM_H

#include <InterViews/menu.h>
#include "3dmenuitem.h"

#define SLEEP_TIME 100000		/* Time to pause between menu flashes	*/
#define pad 3				/* Space around menu items		*/

typedef void (*Command)(void*);

class Event;
class Color;

class CommandItem : public ThreeDMenuItem

{
public:
  CommandItem(const char* name, Command menuFunction, 
	      void* what, char* key = "");			// Constructor
  virtual ~CommandItem();
  virtual void Reconfig();					// Sets item's shape
  virtual void Handle(Event& e);				// Handle an event
  virtual void Do();						// Called when picked
protected:
  Command whatFunction;						// What function to call
  void* whatObject;						// What object to call
  void Wait(int sec, int usec);					// pause for usec useconds
  int padding;							// Padding around menu items
};

#endif






