// This file is part of xplot.
// 
// Copyright (C) 1989 Rene' Seindal (seindal@diku.dk)
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


#ifndef plotframe_h
#define plotframe_h

class PlotFrame;			// Top-level interactor for xplot.

#include <InterViews/scene.h>

class Banner;
class ButtonState;
class PlotGraphSet;
class PlotCanvas;
class PlotView;
class PanelButton;

class PlotFrame : public MonoScene {
private:
    void Init(PlotGraphSet *, const char *, const char *);

    Banner *headline;
    const char *name;
    const char *file;

    PlotCanvas *pcanvas;
    PlotView *view_port;
    PlotGraphSet *graphset;

    ButtonState *state;
    PanelButton *prev_button;
    PanelButton *next_button;
    void ManageButtons();
public:
    PlotFrame(PlotGraphSet *, const char *, const char *);
    PlotFrame(PlotFrame *, const char *geometry = nil);	// messy
    ~PlotFrame();

    void Update();

    void Replot();			// redraw this view
    void Previous();			// go to previous graph
    void Next();			// go to next graph

    void NewView();			// create new view
    void DeleteView();			// delete this view
    void DeleteAll();			// delete all views on a file
    void Quit();			// quit xplot

    void Normalize();			// normalize viewport
    void Magnify();			// magnify perspective
    void OneToOne();			// aspect ratio 1.
};

#endif /* plotframe_h */
