/* File: toolbox.h
 * Created: 3/28/92 by Jason Barshay(jb60@andrew.cmu.edu)
 * Description:
 *	
 * Modifications:
 */

/*
 * Toolbox - a class for creating a GEMS toolbox
 */

#ifndef gems_mapwindow_h
#define gems_mapwindow_h

#include <InterViews/window.h>

#include "selector.h"
#include "selection.h"
#include "viewer.h"

class DrawingBox;

class Map {
public:
  Map(char* = "Jasonville");
  
  void status_line(char* value);
  char* status_line();

  void selection_cb();
  DrawingBox* drawing_box() { return(_drawing_box); }
  Selector* selector() {return (_selector);}
  char* name() {return (_name);}
  void set_name(char*);
  void display();
  class Selection* get_selection() {return (_selection);}
  Viewer* viewer() {return (_viewer);}
private:
  char* _name;
  Selector* _selector;
  class Selection* _selection;
  DrawingBox* _drawing_box;
  Viewer* _viewer;
  class GemsLabel* _status_line;
  TopLevelWindow* _window;
};

#endif
