// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:44:03 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	Timer.h,v $
 * Revision 1.2  91/11/04  19:44:03  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:04  sanjay
 * Initial deposit
 * 
 */
#ifndef TIMERH
#define TIMERH

#include "Time.h"

/*
 * A Timer manages a number of timer events.
 */

class Closure;
class TimerActionPArray;

class TimerAction {
  public:
    TimerAction(Time, Closure*);
    ~TimerAction();

    Time	GetTime();
    Closure*	GetClosure();
  protected:
    Time	time;
    Closure*	closure;
};

class Timer {
  public:
    Timer();
    ~Timer();

    /* Status */
    int  Pending();		/* Is there a pending event */
    Time NextFire();		/* When is next event supposed to fire */

    /* Add and remove timer events */
    TimerAction*	FireAt(Time, Closure*);
    void		Remove(TimerAction*);
    int			Contains(TimerAction*);

    /* Clock tick - set off expired timers */
    void		Tick();
  protected:
    TimerActionPArray&	queue;
};

inline Time TimerAction::GetTime() {
    return time;
}

inline Closure* TimerAction::GetClosure() {
    return closure;
}

#endif /*TIMERH */
