/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:44:06 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	Year.cc,v $
 * Revision 1.2  91/11/04  19:44:06  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/06/28  20:07:16  sanjay
 * Initial revision
 * 
 */

#include "Year.h"

int Year::first = 1900;
int Year::last = 2400;
int Year::first_century = (Year::first - 1) / 100;
int Year::first_year_off = first - 100 * first_century;

long Year::first_day_off = (long((first_year_off - 1) / 4) +
			    365L * long(first_year_off - 1));

unsigned long Year::Century_Size(int c) {
    return (((c + 1) % 4) == 0) ? 36525L : 36524L;
}

long Year::Century_Offset(int c) {
    long offset = 0L;
    int i;

    for (i = Year::FirstCentury(); i < c; i++) {
	offset += Century_Size(i);
    }

    for (i = Year::FirstCentury() - 1; i >= c; i--) {
	offset -= Century_Size(i);
    }

    return offset - first_day_off;
}

long Year::Offset(int year) {
    int c = (year - 1) / 100;
    int z = year - 100 * c;

    return Century_Offset(c) + ((z - 1) / 4) + 365 * (z - 1);
}
