/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:44:12 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	alllist.cc,v $
 * Revision 1.3  91/11/04  19:44:12  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:51:41  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:41:51  sanjay
 * Initial deposit
 *
 */

#include "alllist.h"
#include "item.h"
#include "noteinfo.h"
#include "NoteInfoP.List.h"

AllList::AllList(Application* a)
     : DisplayList(a)
{
    SetClassName("AllList");

    Date today = Date::Today();
    date = today - 1;
    SetDate(today);
}

boolean AllList::Contains(Item* i) {
    return true;
}

/*
 * Do not allow children creation.
 */
Item* AllList::MakeItem(Event& e) {
    return nil;
}

NoteInfo* AllList::MakeChild(Item* item) {
    return DisplayList::MakeChild(item);
}

/*
 * Sort items by occurrence.
 */
void AllList::FixLayout() {
    NoteInfoPList* list = new NoteInfoPList;

    while (! children->Empty()) {
	NoteInfo* info = children->First()->Element();
	children->Remove(children->First());

	/* Insert info in correct place in list */
	NoteInfoPCell* cell = list->First();
	while (1) {
	    if (! cell) {
		/* Info occurs after every item in list */
		list->Append(info);
		break;
	    }
	    if (Item::OccursBefore(info->Get(), cell->Element()->Get())) {
		cell->AddBefore(info);
		break;
	    }
	    cell = cell->Next();
	}
    }

    delete children;
    children = list;

    /* Now just do normal layout on sorted list. */
    DisplayList::FixLayout();
}

