/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.10 $
 * $Date: 91/11/28 14:48:27 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	allview.cc,v $
 * Revision 1.10  91/11/28  14:48:27  sanjay
 * Renamed Closure(T) to Closure1(T)
 * 
 * Revision 1.9  91/11/04  19:44:14  sanjay
 * Prepare for release
 * 
 * Revision 1.8  91/08/06  13:54:47  sanjay
 * Error popups are now centered on the mouse.
 * 
 * Revision 1.7  91/04/16  15:22:32  sanjay
 * Made closures reference counted
 * 
 * Revision 1.6  91/04/11  13:30:42  sanjay
 * Fixed window popup
 * 
 * Revision 1.5  91/04/01  20:30:30  sanjay
 * Better IO error handling
 * 
 * Revision 1.4  91/04/01  11:56:57  sanjay
 * Added include file capability
 * 
 * Revision 1.3  91/03/29  16:22:02  sanjay
 * Popup message on usage error
 * 
 * Revision 1.2  91/03/28  11:51:42  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:41:51  sanjay
 * Initial deposit
 *
 */

#include <InterViews/glue.h>
#include <InterViews/menu.h>
#include <InterViews/box.h>
#include <InterViews/border.h>
#include <InterViews/scroller.h>
#include "Date.h"
#include "allview.h"
#include "dayview.h"
#include "xworld.h"
#include "closure.h"
#include "menuclosure.h"
#include "item.h"
#include "application.h"
#include "alllist.h"
#include "popup.h"

declare(Closure,AllView);
implement(Closure,AllView);

AllView::AllView(Application* a) {
    SetClassName("AllView");
    SetName("Item List");

    application = a;
    application->AddView();

    Layout();
}

AllView::~AllView() {
    application->RemoveView();
}

void AllView::Layout() {
    Closure* gotoClosure	= new Closure1(AllView)(this, AllView::Goto);
    Closure* newDayClosure	= new Closure1(AllView)(this, AllView::NewDay);
    Closure* closeClosure	= new Closure1(AllView)(this, AllView::Close);

    MenuBar* menuBar = new MenuBar;

    PulldownMenu* viewMenu = new PulldownMenu("View");
    viewMenu->Include(new MenuClosure("Goto Item",	gotoClosure));
    viewMenu->Include(new MenuClosure("New View",	newDayClosure));
    viewMenu->Include(new MenuClosure("Close",		closeClosure));

    menuBar->Include(viewMenu);
    menuBar->Include(new Control(new HGlue));

    view = new AllList(application);

    Insert(new VBox(menuBar, new HBorder, new HBox(new VScroller(view),view)));
}

Item* AllView::Selection() {
    Item* i = view->Selection();
    if (i == nil) {
	Warn("No item selected.");
    }
    return i;
}

void AllView::Goto() {
    Item* i = Selection();
    if (i != nil) {
	application->World()->InsertApplication
	    (new DayView(application, i->FirstDate()));
    }
}

void AllView::NewDay() {
    application->World()->InsertApplication
	(new DayView(application, Date::Today()));
}

void AllView::Close() {
    if (application->OpenViews() > 1) {
	/* There are other open views.  OK to kill this one. */
	delete this;
    }
    else {
	Warn("No other views are open.");
    }
}

void AllView::Warn(const char* msg) {
    Popup* popup = new Popup(msg);
    popup->SetName("Warning");
    application->World()->Popup(popup);
}
