// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.6 $
 * $Date: 91/11/04 19:44:15 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	allview.h,v $
 * Revision 1.6  91/11/04  19:44:15  sanjay
 * Prepare for release
 * 
 * Revision 1.5  91/04/16  15:22:33  sanjay
 * Made closures reference counted
 * 
 * Revision 1.4  91/04/01  20:30:31  sanjay
 * Better IO error handling
 * 
 * Revision 1.3  91/04/01  11:56:58  sanjay
 * Added include file capability
 * 
 * Revision 1.2  91/03/29  16:22:03  sanjay
 * Popup message on usage error
 * 
 * Revision 1.1  91/03/28  11:41:07  sanjay
 * Initial deposit
 * 
 */

#ifndef _ALLVIEWH
#define _ALLVIEWH

/*
 * View all appointments and notices.
 */

#include <InterViews/scene.h>

class AllView;
class Application;
class DisplayList;
class Item;

class AllView : public MonoScene {
  public:
    AllView(Application*);
    virtual ~AllView();
  protected:
    Application* application;
    DisplayList* view;

    void Layout();

    /* Obtain Selection for read-only operation */
    Item* Selection();

    /* Item selection for mutator operation */
    Item* ModSelection();

    /* Menu operations */
    void Goto();
    void NewDay();
    void Close();

    void Warn(char const*);
};

#endif /* _ALLVIEWH */
