/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.4 $
 * $Date: 91/11/04 19:44:19 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	appteditor.cc,v $
 * Revision 1.4  91/11/04  19:44:19  sanjay
 * Prepare for release
 * 
 * Revision 1.3  91/08/06  14:14:00  sanjay
 * Removed source of warnings.
 * 
 * Revision 1.2  91/03/28  11:51:43  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:41:53  sanjay
 * Initial deposit
 *
 */

#include "appteditor.h"
#include <InterViews/textdisplay.h>
#include <InterViews/sensor.h>
#include <InterViews/event.h>

ApptEditor::ApptEditor() : SimpleEditor(3, 40) {
    SetClassName("DayAppt");
    display->CaretStyle(NoCaret);
    input->Ignore(KeyEvent);
    input->Ignore(UpEvent);
    input->Ignore(DownEvent);
    Listen(input);
}

void ApptEditor::Unfocussed() {
    display->CaretStyle(NoCaret);
}

void ApptEditor::Focussed() {
    display->CaretStyle(BarCaret);
}

void ApptEditor::Handle(Event& e) {
    switch (e.eventType) {
      case DownEvent:
	if (e.button == LEFTMOUSE) {
	    Select(Locate(e.x, e.y));
	    ScrollToSelection();
	}
	break;
      case KeyEvent:
	if (e.meta)
	    HandleMetaChar(e.keystring[0]);
	else
	    HandleChar(e.keystring[0]);
	break;
      default:
	break;
    }
}
