// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.3 $
 * $Date: 91/11/28 16:24:20 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	apptview.h,v $
 * Revision 1.3  91/11/28  16:24:20  sanjay
 * CFRONT compatibility
 * 
 * Revision 1.2  91/11/04  19:44:24  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:10  sanjay
 * Initial deposit
 * 
 */
#ifndef _APPTVIEWH
#define _APPTVIEWH

/*
 * Abstract class that views Items.
 */
#include <generic.h>

class Application;
class NoteInfo;
class Item;
class Interactor;

class ApptView {
  public:
    ApptView(Application*);
    virtual ~ApptView();

    /*
     * Item manipulation callbacks.
     */
    enum ApptViewItemMsg {
	Change,		/* Item has changed */
	Delete,		/* Item is about to be deleted */
	Add		/* Item has just been added */
	};
    virtual void ItemMsg(ApptViewItemMsg, Item*) = 0;

    /*
     * Other messages.
     */
    enum ApptViewMsg {
	Save,		/* Save any pending changes */
	Focus,		/* Notification on focus */
	Unfocus		/* Notificiation on unfocus */
	};
    virtual void Msg(ApptViewMsg) = 0;

    Application* App();
  protected:
    Application* application;
};

inline Application* ApptView::App() {
    return application;
}

/*
 * Create ApptView subclass that forwarder ApptView messages
 * to objects of a specific class T.
 */

#define AVForwarder(T) name2(AVForwarder,T)

#define AVForwarderdeclare(T)						\
class AVForwarder(T) : public ApptView {				\
  public:								\
    AVForwarder(T)(Application*, T*);					\
									\
    virtual void ItemMsg(ApptViewItemMsg, Item*);			\
    virtual void Msg(ApptViewMsg);					\
  protected:								\
    T*			delegate;					\
};

#define AVForwarderimplement(T)						\
AVForwarder(T)::AVForwarder(T)(Application* a, T* t) : (a) {		\
    delegate = t;							\
}									\
									\
void AVForwarder(T)::ItemMsg(ApptViewItemMsg t, Item* item) {		\
    delegate->ItemMsg(t, item);						\
}									\
									\
void AVForwarder(T)::Msg(ApptViewMsg t) {				\
    delegate->Msg(t);							\
}									\

#endif /* _APPTVIEWH */
