/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.4 $
 * $Date: 91/11/04 19:44:28 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	buttonclosure.cc,v $
 * Revision 1.4  91/11/04  19:44:28  sanjay
 * Prepare for release
 * 
 * Revision 1.3  91/04/16  15:22:37  sanjay
 * Made closures reference counted
 * 
 * Revision 1.2  91/03/28  11:51:45  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:41:57  sanjay
 * Initial deposit
 *
 */

#include "buttonclosure.h"
#include "closure.h"

ButtonClosure::ButtonClosure(char const* text, Closure* c)
     : (text, new ButtonState(0), 1)
{
    closure = c;
    closure->Reference();
    Unref(subject);
}

ButtonClosure::~ButtonClosure() {
    Unref(closure);
}

void ButtonClosure::Press() {
    closure->Invoke();
}
