/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.6 $
 * $Date: 91/11/28 14:48:34 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	calargs.cc,v $
 * Revision 1.6  91/11/28  14:48:34  sanjay
 * Renamed Closure(T) to Closure1(T)
 * 
 * Revision 1.5  91/11/04  19:44:30  sanjay
 * Prepare for release
 * 
 * Revision 1.4  91/04/16  15:22:39  sanjay
 * Made closures reference counted
 * 
 * Revision 1.3  91/04/01  17:26:41  sanjay
 * Added -list as a synonym for -remindOnly.
 * 
 * Revision 1.2  91/03/28  11:51:46  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:41:58  sanjay
 * Initial deposit
 *
 */

#include "calargs.h"
#include "closure.h"
#include "arglist.h"

declare(Closure,CalArgs);
implement(Closure,CalArgs);

CalArgs::CalArgs(int argc, char* argv[]) : (argc, argv) {
    Closure* fileClosure = new Closure1(CalArgs)(this, CalArgs::FileName);
    Closure* remClosure  = new Closure1(CalArgs)(this, CalArgs::RemindOnly);

    Parser()->AddOption("-calendar",	fileClosure);
    Parser()->AddOption("-remindOnly",	remClosure);
    Parser()->AddOption("-list",	remClosure);

    saveFile = 0;
    remindOnly = 0;
}

void CalArgs::FileName() {
    if (Parser()->Remaining() < 1) {
	/* No next argument - save this one away as unrecognized */
	Save(Parser()->Fetch());
    }
    else {
	saveFile = Parser()->Fetch(1);
	Parser()->Advance();
    }
}

void CalArgs::RemindOnly() {
    remindOnly = 1;
}
