// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.4 $
 * $Date: 91/11/04 19:44:33 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	calendar.h,v $
 * Revision 1.4  91/11/04  19:44:33  sanjay
 * Prepare for release
 * 
 * Revision 1.3  91/08/06  09:47:46  sanjay
 * Calendar does not read included files. It just stores their names.
 * 
 * Revision 1.2  91/04/01  11:57:02  sanjay
 * Added include file capability
 * 
 * Revision 1.1  91/03/28  11:41:13  sanjay
 * Initial deposit
 * 
 */
#ifndef _CALENDARH
#define _CALENDARH

#include <InterViews/defs.h>
#include <stdio.h>
#include "basic.h"

class Item;
class Lexer;
class PointerArray;

class Calendar {
  public:
    Calendar();			/* Create a new calendar */
    ~Calendar();

    /*
     * Item list.
     */
    int Size() const;			/* Number of items */
    Item* Get(int) const;		/* Get the ith item */
    void Add(Item*);			/* Add an item */
    void Remove(Item*);			/* Remove an item */

    /*
     * Included calendars.
     */
    void Include(char const*);
    void Exclude(char const*);

    int  NumIncludes() const;
    char const* GetInclude(int) const;

    /*
     * True iff this calendar is read-only.
     */
    boolean ReadOnly() const;
    void SetReadOnly(boolean);

    /*
     * Read/Write.
     */
    boolean Read(Lexer*);
    void Write(FILE*) const;
  protected:
    /*
     * Items.
     */
    PointerArray& items;

    /*
     * Included calendars.
     */
    PointerArray& includes;

    boolean readonly;
};

inline boolean Calendar::ReadOnly() const {
    return readonly;
}

inline void Calendar::SetReadOnly(boolean t) {
    readonly = t;
}

#endif /* _CALENDARH */
