// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.5 $
 * $Date: 91/11/28 16:24:26 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	closure.h,v $
 * Revision 1.5  91/11/28  16:24:26  sanjay
 * CFRONT compatibility
 * 
 * Revision 1.4  91/11/28  14:48:58  sanjay
 * Renamed Closure(T) to Closure1(T)
 * 
 * Revision 1.3  91/11/04  19:44:37  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/04/16  15:22:40  sanjay
 * Made closures reference counted
 * 
 * Revision 1.1  91/03/28  11:41:14  sanjay
 * Initial deposit
 * 
 */
#ifndef _CLOSUREH
#define _CLOSUREH

/*
 * <Object, Method> closures.
 */
#include <generic.h>
#include <InterViews/resource.h>

class Closure : public Resource {
  public:
    virtual void Invoke() = 0;
};

#define Closure1(T) name2(Closure,T)
#define _ClosureHook(T) name2(_ClosureHook,T)

#define Closuredeclare(T)						\
typedef void (T::*_ClosureHook(T))();					\
									\
class Closure1(T) : public Closure {					\
  public:								\
    Closure1(T)(T*, _ClosureHook(T));					\
    virtual void Invoke();						\
  private:								\
    T* delegate;		/* Target object */			\
    _ClosureHook(T) hook;	/* Method pointer */			\
};

#define Closureimplement(T)						\
Closure1(T)::Closure1(T)(T* d, _ClosureHook(T) h) {			\
    delegate = d;							\
    hook = h;								\
}									\
									\
void Closure1(T)::Invoke() {						\
    (delegate->*hook)();						\
}

#endif /* _CLOSUREH */
