// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:44:43 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	datestate.h,v $
 * Revision 1.2  91/11/04  19:44:43  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:16  sanjay
 * Initial deposit
 * 
 */

#ifndef _DATESTATEH
#define _DATESTATEH

#include <InterViews/subject.h>
#include "Date.h"

/*
 * Maintains a Date.
 */

class DateState : public Subject {
  public:
    DateState(Date);

    Date GetDate() const;
    void SetDate(Date d);
  protected:
    Date date;
};

inline DateState::DateState(Date d) {
    date = d;
}

inline Date DateState::GetDate() const {
    return date;
}

inline void DateState::SetDate(Date d) {
    if (date != d) {
	date = d;
	Notify();
    }
}

#endif /* _DATESTATEH */
