/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.6 $
 * $Date: 91/11/28 14:48:42 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	extractargs.cc,v $
 * Revision 1.6  91/11/28  14:48:42  sanjay
 * Renamed Closure(T) to Closure1(T)
 * 
 * Revision 1.5  91/11/04  19:44:55  sanjay
 * Prepare for release
 * 
 * Revision 1.4  91/06/28  14:32:44  sanjay
 * Make array deletions portable.
 * 
 * Revision 1.3  91/04/16  15:22:46  sanjay
 * Made closures reference counted
 * 
 * Revision 1.2  91/03/28  11:51:50  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:06  sanjay
 * Initial deposit
 *
 */

#include "config.h"
#include "extractargs.h"
#include "closure.h"
#include "arglist.h"

declare(Closure,ExtractArgs);
implement(Closure,ExtractArgs);

ExtractArgs::ExtractArgs(int argc, char* argv[]) {
    Closure* failClosure = new Closure1(ExtractArgs)(this, ExtractArgs::Fail);

    parser	= new ArgList(argc, argv, failClosure);
    size	= argc;
    args	= new char*[size];
    args[0]	= argv[0];
    num		= 1;
}

ExtractArgs::~ExtractArgs() {
    delete parser;
    deleteArray(size) args;
}

ArgList* ExtractArgs::Parser() {
    return parser;
}

int& ExtractArgs::Argc() {
    return num;
}

char** ExtractArgs::Argv() {
    return args;
}

void ExtractArgs::Fail() {
    Save(parser->Fetch());
}

void ExtractArgs::Save(char* arg) {
    args[num++] = arg;
}
