// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:44:56 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	extractargs.h,v $
 * Revision 1.3  91/11/04  19:44:56  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/04/16  15:22:47  sanjay
 * Made closures reference counted
 * 
 * Revision 1.1  91/03/28  11:41:19  sanjay
 * Initial deposit
 * 
 */

#ifndef _EXTRACTARGSH
#define _EXTRACTARGSH

/*
 * A client of ArgList that saves the arguments that it does
 * not understand.  The saved argument list can be passed to
 * an InterViews World constructor.
 */

class ArgList;

class ExtractArgs {
  public:
    ExtractArgs(int argc, char* argv[]);
    virtual ~ExtractArgs();

    ArgList* Parser();

    int&   Argc();
    char** Argv();
  protected:
    void Fail();		/* Called on unrecognized argument */
    void Save(char*);		/* Save unrecognized argument */

    ArgList*	parser;		/* Arg list parser */
    int		num;		/* Number of unrecognized args so far */
    char**	args;		/* Array of unrecognized arguments */
    int		size;		/* Size of args */
};

#endif /* _EXTRACTARGSH */
