// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:45:02 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	fieldshower.h,v $
 * Revision 1.2  91/11/04  19:45:02  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:21  sanjay
 * Initial deposit
 * 
 */

#ifndef _FIELDSHOWERH
#define _FIELDSHOWERH

#include <InterViews/interactor.h>

class FieldState;

/*
 * A FieldShower displays the state of some Field (see field.h)
 */
class FieldShower : public Interactor {
  public:
    FieldShower(FieldState*,              Alignment = Left);
    FieldShower(const char*, FieldState*, Alignment = Left);
    virtual ~FieldShower();

    virtual void Redraw(Coord,Coord,Coord,Coord);

    virtual void Refresh();	/* Redraw stuff */
    virtual void Update();	/* Handle change in associated StringState */
    virtual void Reconfig();	/* Handle changes in shapes and stuff */
  protected:
    FieldState* subject;	/* Associated string */
    Coord       minWidth;	/* Minimum width of field */
    Alignment	align;		/* Alignment */
    Coord	pad;		/* Padding */
  private:
    void Init(FieldState*, Alignment); /* Initialize structure */
};

#endif /* _FIELDSHOWERH */
