/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:45:03 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	filemap.cc,v $
 * Revision 1.2  91/11/04  19:45:03  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/08/05  17:14:02  sanjay
 * Initial revision
 * 
 *
 */

#include <string.h>
#include "Pointer.Array.h"
#include "filemap.h"
#include "calfile.h"

FileMap::FileMap() {
    map = new PointerArray;
}

FileMap::~FileMap() {
    delete map;
}

void FileMap::Add(CalFile* file) {
    map->Append((Pointer) file);
}

void FileMap::Remove(CalFile* file) {
    for (int index = map->Size() - 1; index >= 0; index--) {
	if (file == ((CalFile*) map->Slot(index))) {
	    /* Shift map[index+1..] to map[index..] */
	    for (int i = index + 1; i < map->Size(); i++) {
		map->Slot(i-1) = map->Slot(i);
	    }

	    map->Remove();
	}
    }
}

CalFile* FileMap::Lookup(Calendar* cal) {
    for (int i = map->Size() - 1; i >= 0; i--) {
	CalFile* file = (CalFile*) map->Slot(i);

	if (file->GetCalendar() == cal) {
	    return file;
	}
    }

    return 0;
}

CalFile* FileMap::Lookup(char const* name) {
    for (int i = map->Size() - 1; i >= 0; i--) {
	CalFile* file = (CalFile*) map->Slot(i);

	if (strcmp(file->GetName(), name) == 0) {
	    return file;
	}
    }

    return 0;
}

int FileMap::Size() {
    return map->Size();
}

CalFile* FileMap::Get(int index) {
    return (CalFile*) map->Slot(index);
}
