/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:05 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	focusframe.cc,v $
 * Revision 1.3  91/11/04  19:45:05  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:51:52  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:10  sanjay
 * Initial deposit
 *
 */

#include <InterViews/painter.h>
#include "focusframe.h"

FocusFrame::FocusFrame(Interactor* i, int w) : (i, 4 * w, w, 4 * w, w) {
    SetClassName("ApptFrame");
    focussed = false;
}

void FocusFrame::SetFocus(boolean f) {
    if (focussed != f) {
	focussed = f;
	if (canvas != nil) {
	    output->ClearRect(canvas, 0, 0, xmax, ymax);
	    Redraw(0, 0, xmax, ymax);
	}
    }
}

void FocusFrame::Redraw(Coord l, Coord b, Coord r, Coord t) {
    if (focussed) {
	Frame::Redraw(l, b, r, t);
    }
    else {
	/* Pretend that all sides of frame are same width */
	Coord oldL = left;
	Coord oldR = right;

	left = top;
	right = top;
	Frame::Redraw(l, b, r, t);
	left = oldL;
	right = oldR;
    }
}
