// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.6 $
 * $Date: 91/11/04 19:45:13 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	iremind.h,v $
 * Revision 1.6  91/11/04  19:45:13  sanjay
 * Prepare for release
 * 
 * Revision 1.5  91/08/06  09:54:19  sanjay
 * Get item list from application instead of calendar.
 * 
 * Revision 1.4  91/04/10  11:33:26  sanjay
 * Added printing
 * 
 * Revision 1.3  91/04/03  21:36:33  sanjay
 * Added range listing
 * 
 * Revision 1.2  91/04/03  20:39:38  sanjay
 * Put reminders in window instead of piping
 * 
 * Revision 1.1  91/03/28  11:41:24  sanjay
 * Initial deposit
 * 
 */

#ifndef _IREMINDH
#define _IREMINDH

#include <InterViews/defs.h>

class Application;
class Date;
class Item;
class Printer;

class IRemind {
  public:
    static void Remind(Printer*, Application*, Date, Date);
    static void PSPrintMonth(Printer*, Application*, Date);
    static void PSPrintDays(Printer*, Application*, Date,
			    int num, int cols, boolean landscape);

    static void PSPrint(Printer*, Application*, Date, Date,
			int columns, int firstOffset = 0);
  private:
    struct Remind_Info {
	Date  date;		/* Date of occurrence */
	Item* item;		/* Item */
    };

    static int  Precedes(Remind_Info*, Remind_Info*);
    static void CollectReminders(Application*, Date first, Date last,
				 class PointerArray&);
    static void PrintReminders(Printer*, class PointerArray&);
    static void PrintTime(Printer*, int);
    static void PrintDate(Printer*, Date);
    static void PrintItem(Printer*, Item*);

    static void PSPrintDay(Printer*, Application*, Date, class PointerArray&);
    static void PSPrintHeader(Printer*);
    static void PSPrintPrintingTime(Printer*);
};

#endif /* _IREMINDH */
