// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:45:18 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	labelgrid.h,v $
 * Revision 1.2  91/11/04  19:45:18  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:25  sanjay
 * Initial deposit
 * 
 */

#ifndef LABELGRIDH
#define LABELGRIDH

#include <InterViews/interactor.h>

/*
 * Display a grid of labels.
 */
class LabelGrid : public Interactor {
  public:
    LabelGrid(int cols, int rows);
  protected:
    /*
     * Grid contents - defined by subclasses.
     */
    virtual void Paint(Coord, Coord, Coord, Coord, int col, int row)	= 0;
    virtual void GetExtent(int col, int row, Coord& w, Coord& h)	= 0;

    /*
     * Interactor shape and contents.
     */
    virtual void Reconfig();
    virtual void Redraw(Coord, Coord, Coord, Coord);

    /*
     * The actual grid.
     */
    int columns;
    int rows;

    int FindRow(Coord);
    int FindColumn(Coord);

    Coord FindLeft(int);
    Coord FindRight(int);
    Coord FindBottom(int);
    Coord FindTop(int);

    /*
     * Display info.
     */
    int hpad, vpad;
    int maxWidth, maxHeight;
};    

#endif /*LABELGRIDH */
