/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:25 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	mdayset.cc,v $
 * Revision 1.3  91/11/04  19:45:25  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:51:58  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:18  sanjay
 * Initial deposit
 *
 */

#include <stdio.h>
#include "mdayset.h"

MDaySet::MDaySet() {
    SetClassName("MDaySet");
    value.Clear();
}

void MDaySet::Edit(SmallIntSet s) {
    SmallIntSet oldValue = value;
    value = s;

    for (int i = 1; i <= 31; i++) {
	if (oldValue.Member(i)) {
	    if (! value.Member(i))
		Changed(i);
	}
	else {
	    if (value.Member(i))
		Changed(i);
	}
    }
}

void MDaySet::Hit(int day) {
    if (value.Member(day)) {
	value.Remove(day);
    }
    else {
	value.Insert(day);
    }
    Changed(day);
}

boolean MDaySet::Selected(int day) {
    return value.Member(day);
}
