/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:35 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	monthset.cc,v $
 * Revision 1.3  91/11/04  19:45:35  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:52:01  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:22  sanjay
 * Initial deposit
 *
 */

#include <stdio.h>
#include "monthset.h"

MonthSet::MonthSet() {
    SetClassName("MonthSet");
    value.Clear();
}

void MonthSet::Edit(SmallIntSet s) {
    SmallIntSet oldValue = value;
    value = s;

    for (int i = 1; i <= 31; i++) {
	if (oldValue.Member(i)) {
	    if (! value.Member(i))
		Changed(i);
	}
	else {
	    if (value.Member(i))
		Changed(i);
	}
    }
}

void MonthSet::Hit(int month) {
    if (value.Member(month)) {
	value.Remove(month);
    }
    else {
	value.Insert(month);
    }
    Changed(month);
}

boolean MonthSet::Selected(int month) {
    return value.Member(month);
}
