// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:41 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	notelist.h,v $
 * Revision 1.3  91/11/04  19:45:41  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/08/06  09:56:03  sanjay
 * Notify DayView of selection changes.
 * 
 * Revision 1.1  91/03/28  11:41:37  sanjay
 * Initial deposit
 * 
 */

#ifndef _NOTELISTH
#define _NOTELISTH

#include "displaylist.h"
class Date;
class DayView;

/*
 * Display notices for a given day.
 *
 * Class Name:
 *	NoteList
 */
class NoteList : public DisplayList {
  public:
    NoteList(Application*, DayView*, Date);
    virtual ~NoteList();

    virtual void Edit(NoteInfo*);
    virtual void FinishEdit();
  protected:
    virtual boolean Contains(Item*);

    virtual void SetShape();

    virtual void Handle(Event&);
    virtual void HandleResizeEvent(Event&);
    
    virtual Item*     MakeItem(Event&);
    virtual NoteInfo* MakeChild(Item*);

    boolean resizing;
    boolean trackBottom;

    DayView* dayview;
};

#endif /* _NOTELISTH */
