// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * Maintain item occurrence information.
 */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:45:43 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	occurcache.h,v $
 * Revision 1.2  91/11/04  19:45:43  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/09/18  20:31:27  sanjay
 * Initial revision
 * 
 *
 */
#ifndef _OCCURCACHE_H
#define _OCCURCACHE_H

#include "Date.h"

class Application;
class Item;

class OccurCache {
  public:
    OccurCache(Application* a);
    virtual ~OccurCache();

    /* Number of items on particular date */
    int NumberOn(Date);

    /* Is specified item on particular date */
    boolean ItemIsOn(Item*, Date);

    /* Preload cache with a certain range of dates */
    void Preload(Date start, int days);

    /* callbacks for item changes */
    void Changed(Item*);
    void Added(Item*);
    void Removed(Item*);
  private:
    /* Return cache entry for specified date - create if necessary */
    class DateItemCell* GetCacheEntry(Date);

    /* Return cache entry - return nil if not found */
    class DateItemCell* FindCacheEntry(Date);

    /* Date -> ItemPList partial map. Maintained in LRU order */
    class DateItemList* cache;

    /* Maximum allowable cache size (> 0) */
    int maxSize;

    /* Current cache size (<= maxSize) */
    int size;

    Application* application;
};

#endif /* _OCCURCACHE_H */
