// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.4 $
 * $Date: 91/11/04 19:45:49 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	reminder.h,v $
 * Revision 1.4  91/11/04  19:45:49  sanjay
 * Prepare for release
 * 
 * Revision 1.3  91/09/11  20:21:25  sanjay
 * Added button to suppress all reminders for appt.
 * 
 * Revision 1.2  91/04/16  15:22:51  sanjay
 * Made closures reference counted
 * 
 * Revision 1.1  91/03/28  11:41:39  sanjay
 * Initial deposit
 * 
 */

#ifndef _REMINDERH
#define _REMINDERH

/*
 * Appointment reminder.
 */

#include <InterViews/scene.h>
#include "Time.h"

class Appointment;
class RemindMgr;
class TextBuffer;
class Reminder_TE;

class Reminder;

class Reminder : public MonoScene {
  public:
    Reminder(RemindMgr*, Appointment*, Time apptStart, int minutesLeft);
    virtual ~Reminder();

    void Tick(int minutesRemaining);
  protected:
    /*
     * Components.
     */
    RemindMgr* mgr;
    int minutesLeft;		/* Time to start of appt */

    Reminder_TE* display;	/* Displays text */
    TextBuffer*  textBuffer;
    char*	 region;

    int		remainingLine;	/* Line no. of "remaining minutes" msg */

    void Layout(Appointment*);
    void RecomputeRemaining();

    void InsertText(char const* text);
    void InsertTime(int timeOfDay);

    /* Called to snooze */
    void Snooze();

    /* Called to shutup this and further reminders */
    void ShutUp();
};

#endif /* _REMINDERH */
