// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * Select an included calendar and invoke specified function.
 */

/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:54 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	selectinclude.h,v $
 * Revision 1.3  91/11/04  19:45:54  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/11/01  14:48:32  sanjay
 * Fixed up menu item display.
 * 
 * Revision 1.1  91/08/05  17:14:06  sanjay
 * Initial revision
 * 
 *
 */

#ifndef _SELECTINCLUDEH
#define _SELECTINCLUDEH

#include "dmenu.h"

class Application;
class DayView;

class SelectInclude : public DMenu {
  public:
    SelectInclude(char const* title,
		  Application*,
		  boolean showTop,
		  DayView*,
		  void (DayView::*method)(char const* includeName),
		  ButtonState* enableState = nil, int enableValue = 0);
  protected:
    virtual boolean Changed();
    virtual void FillBody();
  private:
    boolean showTopLevel;
    Application* application;
    DayView* view;
    void (DayView::*method)(char const* includeName);
};

#endif /* _SELECTINCLUDEH */
