// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.2 $
 * $Date: 91/11/04 19:45:56 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	simpleeditor.h,v $
 * Revision 1.2  91/11/04  19:45:56  sanjay
 * Prepare for release
 * 
 * Revision 1.1  91/03/28  11:41:41  sanjay
 * Initial deposit
 * 
 */

#ifndef _SIMPLEEDITORH
#define _SIMPLEEDITORH

#include <InterViews/texteditor.h>

class TextBuffer;

class SimpleEditor : public TextEditor {
  public:
    SimpleEditor(int rows, int cols);
    virtual ~SimpleEditor();

    void Edit(const char*);
    int  Length();
    void Copy(char*);

    virtual void Handle(Event&);

    void SetModified(boolean);		/* Set Modification flag */
    boolean Modified();			/* Get Modification flag */
  protected:
    char* region;

    void NextWord();
    void PrevWord();
    void HandleChar(char);
    void HandleMetaChar(char);

    /* This method is called when the modification flag is changed */
    virtual void ModifyFlagChanged();

    boolean modified;
};

inline void SimpleEditor::SetModified(boolean m) {
    if (modified != m) {
	modified = m;
	ModifyFlagChanged();
    }
}

inline boolean SimpleEditor::Modified() {
    return modified;
}

#endif /* _SIMPLEEDITORH */
