/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.4 $
 * $Date: 91/11/28 16:25:40 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	smallintset.cc,v $
 * Revision 1.4  91/11/28  16:25:40  sanjay
 * CFRONT compatibility
 * 
 * Revision 1.3  91/11/04  19:45:57  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:52:05  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:30  sanjay
 * Initial deposit
 *
 */

#include "smallintset.h"
#include "lexer.h"


unsigned int SmallIntSet::Size() const {
    unsigned int size = 0;

    for (int i = 0; i < SISetLargestMember; i++)
	if (Member(i)) size++;
    return size;
}
boolean SmallIntSet::Read(Lexer* lex) {
    Clear();
    while (true) {
	char c;

	lex->SkipWS();
	if (! lex->Peek(c)) return false;
	if (c == ']') return true;

	int num;
	if (! lex->GetNumber(num)) return false;
	if ((num < 0) || (num > SISetLargestMember)) {
	    lex->SetError("illegal smallintset member");
	    return false;
	}
	Insert(num);
    }
}

void SmallIntSet::Write(FILE* out) const {
    for (int i = 0; i <= SISetLargestMember; i++) {
	if (Member(i)) {
	    fprintf(out, " %d", i);
	}
    }
}
