/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:45:59 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	textpane.cc,v $
 * Revision 1.3  91/11/04  19:45:59  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/04/05  11:53:26  sanjay
 * Made subclass of TextEditor.
 * 
 * Revision 1.1  91/04/03  20:39:40  sanjay
 * Put reminders in window instead of piping
 * 
 *
 */

#include <InterViews/textdisplay.h>
#include <InterViews/textbuffer.h>
#include <InterViews/shape.h>
#include <InterViews/event.h>
#include <InterViews/sensor.h>
#include <bstring.h>
#include "textpane.h"

TextPane::TextPane(const char* text, int len) : (20, 40, 8, Plain) {
    input = new Sensor;
    input->Catch(DownEvent);
    Listen(input);

    buffer_contents = new char[len];
    bcopy(text, buffer_contents, len * sizeof(char));

    buffer = new TextBuffer(buffer_contents, len, len);
    Edit(buffer);
    display->CaretStyle(NoCaret);
}

TextPane::~TextPane() {
    delete buffer;
    delete buffer_contents;
    Unref(input);
}

void TextPane::Handle(Event& e) {
    if (e.eventType == DownEvent) {
	switch (e.button) {
	  case MIDDLEMOUSE:
	    GrabScroll(e);
	    break;
	  case RIGHTMOUSE:
	    RateScroll(e);
	    break;
	  default:
	    break;
	}
    }
}
