// This may look like C code, but it is really -*- C++ -*-
/* Copyright (c) 1991 by Sanjay Ghemawat */

/*
 * $Revision: 1.4 $
 * $Date: 91/11/04 19:46:12 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	xworld.h,v $
 * Revision 1.4  91/11/04  19:46:12  sanjay
 * Prepare for release
 * 
 * Revision 1.3  91/08/06  13:55:13  sanjay
 * Error popups are now centered on the mouse.
 * 
 * Revision 1.2  91/04/11  13:30:51  sanjay
 * Fixed window popup
 * 
 * Revision 1.1  91/03/28  11:41:46  sanjay
 * Initial deposit
 * 
 */

#ifndef _XWORLDH
#define _XWORLDH

#include <InterViews/world.h>

class Timer;

/*
 * Special World class.
 */
class XWorld : public World {
  public:
    XWorld(const char*, PropertyData*, OptionDesc*, int&, char*[]);
    virtual ~XWorld();

    Timer* GetTimer();
    void Run();
    void Next(Event&);

    virtual void Handle(Event&);

    /*
     * Popup specified interactor centered on the background interactor.
     * Nil background means center on screen.
     */
    virtual void Popup(Interactor*, Interactor* background);

    /*
     * Popup specified interactor at current mous location.
     */
    virtual void Popup(Interactor*);
  protected:
    Timer* timer;
};

inline Timer* XWorld::GetTimer() {
    return timer;
}

#endif /* _XWORLDH */
