/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:46:13 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	yearrange.cc,v $
 * Revision 1.3  91/11/04  19:46:13  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:52:09  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:39  sanjay
 * Initial deposit
 *
 */

#include <InterViews/box.h>
#include <InterViews/glue.h>
#include <InterViews/adjuster.h>
#include <InterViews/message.h>
#include "Year.h"
#include "yearrange.h"
#include "field.h"
#include "inteditor.h"

YearRange::YearRange() {
    first = new RangeState(Year::First(), Year::First(), Year::Last());
    last  = new RangeState(Year::Last(),  Year::First(), Year::Last());

    HBox* b = new HBox;

    IntEditor* fe = new IntEditor(first, CenterRight);
    IntEditor* be = new IntEditor(last,  CenterRight);

    b->Insert(new LeftMover(fe, 5));
    b->Insert(fe);
    b->Insert(new RightMover(fe, 5));
    b->Insert(new HGlue(round(0.4 * inches)));
    b->Insert(new Message("to"));
    b->Insert(new HGlue(round(0.4 * inches)));
    b->Insert(new LeftMover(be, 5));
    b->Insert(be);
    b->Insert(new RightMover(be, 5));

    b->Align(Center);
    Insert(b);

    first->Attach(this);
    last->Attach(this);
}

YearRange::~YearRange() {
    first->Detach(this);
    last->Detach(this);
    if (component != nil) delete component;
    delete first;
    delete last;
}

void YearRange::Edit(int f, int l) {
    first->SetMax(l);
    last->SetMin(f);
    first->Set(f);
    last->Set(l);
}

int YearRange::GetFirst() {
    return first->Get();
}

int YearRange::GetLast() {
    return last->Get();
}

void YearRange::Update() {
    first->SetMax(last->Get());
    last->SetMin(first->Get());
}
