/* Copyright (c) 1991 by Sanjay Ghemawat */
/*
 * $Revision: 1.3 $
 * $Date: 91/11/04 19:46:15 $
 * $Author: sanjay $
 * $State: Exp $
 *
 * $Log:	yearselector.cc,v $
 * Revision 1.3  91/11/04  19:46:15  sanjay
 * Prepare for release
 * 
 * Revision 1.2  91/03/28  11:52:09  sanjay
 * Fixed log
 * 
 * Revision 1.1  91/03/28  11:42:40  sanjay
 * Initial deposit
 *
 */

#include <InterViews/box.h>
#include <InterViews/adjuster.h>
#include "Year.h"
#include "yearselector.h"
#include "field.h"
#include "inteditor.h"

YearSelector::YearSelector() {
    state = new RangeState(Year::First(), Year::First(), Year::Last());
    IntEditor* editor = new IntEditor(state, CenterRight);
    HBox* box = new HBox(new LeftMover(editor, 5),
			 editor,
			 new RightMover(editor, 5));
    box->Align(Center);
    Insert(box);
}

YearSelector::~YearSelector() {
    if (component != nil) delete component;
    delete state;
}

void YearSelector::Edit(int y) {
    state->Set(y);
}

int YearSelector::Get() {
    return state->Get();
}
