#include <InterViews/painter.h> 
#include <InterViews/shape.h> 
#include <InterViews/sensor.h> 
#include <InterViews/world.h> 
#include <InterViews/box.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/glue.h> 
#include <InterViews/message.h> 
#include <InterViews/streditor.h> 
#include "GotoDialog.h"
#include <InterViews/2.6/_enter.h>


typedef void (GotoDialog_core::*GotoDialog_core_BFunc)();

class GotoDialog_core_Button : public ButtonState {
public:
    GotoDialog_core_Button(
	int, GotoDialog_core* = nil, GotoDialog_core_BFunc = nil
    );
    virtual void Notify();
private:
    GotoDialog_core_BFunc _func;
    GotoDialog_core* _coreclass;
};

GotoDialog_core_Button::GotoDialog_core_Button(
    int i, GotoDialog_core* coreclass, GotoDialog_core_BFunc f
) : ButtonState(i) {
    _func = f;
    _coreclass = coreclass;
}

void GotoDialog_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

GotoDialog_core::GotoDialog_core (const char* name) : Dialog(
    name, nil, nil
) {
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    state = new GotoDialog_core_Button(0, this, &GotoDialog_core::entered);
    Insert(Interior());
}

Interactor*GotoDialog_core::Interior() {
    gotoBS = state;
    Frame* _Frame_142 = new Frame("_instance_149", nil, 1);
    MarginFrame* _MarginFrame_139 = new MarginFrame("_instance_143", nil, 29, 0, 0, 19, 0, 0);
    VBox* _VBox_111 = new VBox();
    HBox* _HBox_107 = new HBox();
    title = new Message("message", "Goto Line: ", Center);
    HGlue* _HGlue_104 = new HGlue("_instance_104", 20, 20, 1000000);
    _HBox_107->Insert(title);
    _HBox_107->Insert(_HGlue_104);
    VGlue* _VGlue_109 = new VGlue("_instance_109", 5, 5, 1000000);
    Frame* _Frame_140 = new Frame("_instance_144", nil, 1);
    gotoSE = new SelStrEditor("gotoSE", gotoBS, "");
    _Frame_140->Insert(gotoSE);
    VGlue* _VGlue_110 = new VGlue("_instance_110", 7, 7, 1000000);
    HBox* _HBox_108 = new HBox();
    HGlue* _HGlue_106 = new HGlue("_instance_106", 29, 29, 1000000);
    PushButton* _PushButton_102 = new PushButton("button", "Cancel", gotoBS, 2);
    HGlue* _HGlue_105 = new HGlue("_instance_105", 11, 11, 1000000);
    PushButton* _PushButton_103 = new PushButton("button", "OK", gotoBS, 1);
    _HBox_108->Insert(_HGlue_106);
    _HBox_108->Insert(_PushButton_102);
    _HBox_108->Insert(_HGlue_105);
    _HBox_108->Insert(_PushButton_103);
    _VBox_111->Insert(_HBox_107);
    _VBox_111->Insert(_VGlue_109);
    _VBox_111->Insert(_Frame_140);
    _VBox_111->Insert(_VGlue_110);
    _VBox_111->Insert(_HBox_108);
    _MarginFrame_139->Insert(_VBox_111);
    _Frame_142->Insert(_MarginFrame_139);
    return _Frame_142;
};

void GotoDialog_core::entered() {}

