#ifndef Iedit_core_h
#define Iedit_core_h

#include <InterViews/scene.h>

class Shaper;
class MenuItem;
class SelStrEditor;
class ButtonState;
class HBox;
class Message;
class SelEditor;

class Iedit_core : public MonoScene {
public:
    Iedit_core(const char*);
    virtual void Open();
    virtual void New();
    virtual void Save();
    virtual void Quit();
    virtual void Clear();
    virtual void Include();
    virtual void Version();
    virtual void Cut();
    virtual void Copy();
    virtual void Paste();
    virtual void SelectAll();
    virtual void TabSize_4();
    virtual void TabSize_8();
    virtual void _YouChooseTabSize();
    virtual void _CourierMedium12();
    virtual void _CourierBold12();
    virtual void _CourierMedium14();
    virtual void _CourierBold14();
    virtual void _CourierMedium18();
    virtual void _CourierBold18();
    virtual void Search();
    virtual void GotoLine();
    virtual void GoToSelection();
    virtual void MatchBrackets();
    virtual void HelpMe();
    virtual void _Save();
    virtual void _Load();
    virtual void SetWrap();
    virtual void SetIndent();
protected:
    Interactor* Interior();
protected:
    ButtonState* fileNameBS;
    ButtonState* wrapState;
    ButtonState* indentState;
    Shaper* _Shaper;
    MenuItem* Medium12;
    MenuItem* Bold12;
    MenuItem* Mdeium14;
    MenuItem* Bold14;
    MenuItem* Medium18;
    MenuItem* Bold18;
    SelStrEditor* fileName;
    HBox* messageFrame;
    Message* dummyMessage;
    SelEditor* editor;
};

#endif
