// -*- c++ -*-
// RectTester subclass
// dave sternlicht mit X consortium

#include "rect.h"

RectTester::RectTester(Session* s, int repeat) : Tester(s, repeat) {
  objects_ = 1000;
}

void RectTester::proc(Canvas* c, int reps) const {
  const Color* fg = black_;
  int h, i, j;
  float l, b, r, t;
  for (h = 0; h != reps; h++) {
    l = TEST_MARGIN_SIZE; 
    b = HEIGHT - TEST_MARGIN_SIZE - RECT_DIM;
    r = RECT_DIM + TEST_MARGIN_SIZE; 
    t = HEIGHT - TEST_MARGIN_SIZE; 
    for (i = 0; i < RECT_COLS; i++) {
      for (j = 0; j < RECT_ROWS; j++) {
	c->fill_rect(l, b, r, t, fg);
	t -= RECT_DIM + RECT_GAP;
	b -= RECT_DIM + RECT_GAP;
      }
      l += RECT_DIM + RECT_GAP;
      b = HEIGHT - TEST_MARGIN_SIZE - RECT_DIM;
      r += RECT_DIM + RECT_GAP;
      t = HEIGHT - TEST_MARGIN_SIZE;
    }

    b = HEIGHT - TEST_MARGIN_SIZE - RECT_DIM;
    t = HEIGHT - TEST_MARGIN_SIZE;
    if (fg == black_)
      fg = gray_;
    else 
      fg = black_;
  }
}

void RectTester::reportTimes(double time, int n, boolean average) const {
  Tester::reportTimes(time, n, average);
  printf("10x10 rectangle\n");
}


