// -*- c++ -*-
// Interviews tester classes.
// dave sternlicht -- mit x consortium
//

#ifndef tester_h
#define tester_h

#include <InterViews/brush.h>
#include <InterViews/color.h>
#include <InterViews/patch.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/transformer.h>

#include <InterViews/font.h>
#include <InterViews/window.h>
#include <IV-X11/xcanvas.h>
#include <IV-X11/xdisplay.h>
#include <IV-X11/xwindow.h>
#include <OS/string.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

const int WIDTH = 600;
const int HEIGHT = 600;
const Coord  BRUSH_SIZE = 1.0;
const Coord TEST_MARGIN_SIZE = 4.0;
const Coord  RECT_DIM = 10.0;
const Coord RECT_GAP = 1.0;
const int RECT_ROWS = 40;
const int RECT_COLS = 25;
const String  FONT = "6x13";
const Coord XPOS = HEIGHT - 20.0;
const int CHARS_PER_LINE = 80;
const int COLLUMS = 96;

class Tester : public Glyph {
public:
  Tester(Session*, int);
  virtual ~Tester();
  virtual void init(Canvas*, int);
  virtual void proc(Canvas*, int) const {};                      
  virtual void cleanup(Canvas*) const {};
  virtual void allocate(Canvas*, const Allocation&, Extension&);
  virtual void draw(Canvas*, const Allocation&) const;
protected:
  Allocation* alloc_;
  Brush* brush_;
  const Color* gray_;
  const Color* black_;
  Canvas* canvas_;
  Display* dpy_;
  Session* ses_;
  Style* style_;
  Transformer* trans_;
  double syncTime_;
  int calibrateSyncTest(int, double*, int) const;
  int calibrateTest(int, double*, int) const;
  void processTest() const;
  double doTest(int) const;
  void doHardwareSync(Canvas*, int) const;
  void hardwareSync(Canvas*) const;
  void initTimes() const;
  double elapsedTime(double) const;
  virtual void reportTimes(double, int, boolean) const;
  double roundTo3Digits(double) const;
  boolean flip_;
  int objects_;
  int repeat_;
};

#endif tester_h
