/*
 * Copyright (c) 1991 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * User interface builder keycode equivalents.
 */

#ifndef ibkybd_h
#define ibkybd_h

extern const char* KLBL_PMOVE, *CODE_PMOVE;
extern const char* KLBL_PSCALE, *CODE_PSCALE;
extern const char* KLBL_PROTATE, *CODE_PROTATE;
extern const char* KLBL_ABOUT, *CODE_ABOUT;
extern const char* KLBL_CHECKBOX, *CODE_CHECKBOX;
extern const char* KLBL_EXAMINE, *CODE_EXAMINE;
extern const char* KLBL_FBROWSER, *CODE_FBROWSER;
extern const char* KLBL_HBORDER, *CODE_HBORDER;
extern const char* KLBL_HBOX, *CODE_HBOX;
extern const char* KLBL_HGLUE, *CODE_HGLUE;
extern const char* KLBL_HIDEGLUE, *CODE_HIDEGLUE;
extern const char* KLBL_HSCROLLER, *CODE_HSCROLLER;
extern const char* KLBL_MANIP, *CODE_MANIP;
extern const char* KLBL_MESSAGE, *CODE_MESSAGE;
extern const char* KLBL_NATURALSIZE, *CODE_NATURALSIZE;
extern const char* KLBL_NEWVIEW, *CODE_NEWVIEW;
extern const char* KLBL_PUSHBUTTON, *CODE_PUSHBUTTON;
extern const char* KLBL_RADIOBUTTON, *CODE_RADIOBUTTON;
extern const char* KLBL_SHOWGLUE, *CODE_SHOWGLUE;
extern const char* KLBL_STREDIT, *CODE_STREDIT;
extern const char* KLBL_TEXTEDITOR, *CODE_TEXTEDITOR;
extern const char* KLBL_VBORDER, *CODE_VBORDER;
extern const char* KLBL_VBOX, *CODE_VBOX;
extern const char* KLBL_VGLUE, *CODE_VGLUE;
extern const char* KLBL_VSCROLLER, *CODE_VSCROLLER;
extern const char* KLBL_NEWTOOL, *CODE_NEWTOOL;
extern const char* KLBL_TOOLS, *CODE_TOOLS;
extern const char* KLBL_EXE, *CODE_EXE;
extern const char* KLBL_LMOVER, *CODE_LMOVER;
extern const char* KLBL_RMOVER, *CODE_RMOVER;
extern const char* KLBL_UMOVER, *CODE_UMOVER;
extern const char* KLBL_DMOVER, *CODE_DMOVER;
extern const char* KLBL_ENLARGER, *CODE_ENLARGER;
extern const char* KLBL_REDUCER, *CODE_REDUCER;
extern const char* KLBL_PANNER, *CODE_PANNER;
extern const char* KLBL_GRBLOCK, *CODE_GRBLOCK;

extern const char* KLBL_FRAME, *CODE_FRAME;
extern const char* KLBL_SHADOWFRAME, *CODE_SHADOWFRAME;
extern const char* KLBL_MARGINFRAME, *CODE_MARGINFRAME;
extern const char* KLBL_DECK, *CODE_DECK;

extern const char* KLBL_RELATE, *CODE_RELATE;
extern const char* KLBL_MENUITEM, *CODE_MENUITEM;
extern const char* KLBL_PDCMD, *CODE_PDCMD;
extern const char* KLBL_PRCMD, *CODE_PRCMD;
extern const char* KLBL_MBCMD, *CODE_MBCMD;
extern const char* KLBL_SLIDER, *CODE_SLIDER;
extern const char* KLBL_REORDER, *CODE_REORDER;
extern const char* KLBL_PUCMD, *CODE_PUCMD;
extern const char* KLBL_VIEWPORT, *CODE_VIEWPORT;
extern const char* KLBL_MSCLASS, *CODE_MSCLASS;
extern const char* KLBL_DIALOGCLASS, *CODE_DIALOGCLASS;
extern const char* KLBL_SHAPER, *CODE_SHAPER;
extern const char* KLBL_VIEWPARENT, *CODE_VIEWPARENT;
extern const char* KLBL_VIEWROOT, *CODE_VIEWROOT;
extern const char* KLBL_STRBROWSER, *CODE_STRBROWSER;
extern const char* KLBL_NARROW, *CODE_NARROW;
extern const char* KLBL_TAB, *CODE_TAB;
extern const char* KLBL_EDCOMP, *CODE_EDCOMP;
extern const char* KLBL_IBVIEWER, *CODE_IBVIEWER;
extern const char* KLBL_HPCTRL, *CODE_HPCTRL;
extern const char* KLBL_VPCTRL, *CODE_VPCTRL;
extern const char* KLBL_COMMANDCTRL, *CODE_COMMANDCTRL;
#endif
