#include <iostream.h>

#include <InterViews/resource.h>
#include <InterViews/session.h>
#include <InterViews/window.h>

#include <IV-look/kit.h>

#include <rutBase.h>

#include <ruiTextEdit.h>
#include <ruiFileBrowse.h>

//////////
// Main //
//////////

int main(int argc, char** argv) {
  Session* session = new Session("Redwood Design Automation", argc, argv);

  Glyph* FileBrowse = new ruiFileBrowse(Kit::instance(), session->style());
  ApplicationWindow* FileBrowseWindow = new ApplicationWindow(FileBrowse);
  FileBrowseWindow->name("File Browser");
  FileBrowseWindow->map();

  Glyph* textEditor = new ruiTextEdit(Kit::instance(), session->style());
  ApplicationWindow* textEditorWindow = new ApplicationWindow(textEditor);
  textEditorWindow->name("Text Editor");
  textEditorWindow->map();

  session->run();

  delete textEditorWindow;
  delete FileBrowseWindow;

  delete session;

  Resource::flush();

  rutBaseDescriptor* desc;
  for (desc = rutBaseDescriptor::head(); desc; desc = desc->next()) {
    cout << desc->name() << " - total: " << desc->total() << ", count: " <<
      desc->count() << endl;
  }
}
