// This file is part of xplot.
// 
// Copyright (C) 1989 Rene' Seindal (seindal@diku.dk)
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


#ifndef panel_h
#define panel_h

class PanelBox;				// A box containing a panel of buttons.
class PanelButton;			// A simple horizontally stretchable textbutton.
// Command buttons for...
class ButtonReplot;			// redrawing the display.
class ButtonPrevious;			// moving to previous graph.
class ButtonNext;			// moving to next graph.
class ButtonNewView;			// making a new view.
class ButtonDeleteView;			// deleting a view.
class ButtonDeleteAll;			// deleting all views on a graphset.
class ButtonQuit;			// quitting xplot.
class ButtonNormalize;			// normalizing the display.
class ButtonMagnify;			// magnifying (ie zooming in).
class ButtonOneToOne;			// make a aspect ration of one.

#include <InterViews/button.h>
#include <InterViews/box.h>

#include "frame.hh"
class PanelBox : public VBox {
public:
    PanelBox();

    void Reconfig();
};

class PanelButton : public TextButton {
private:
    int width;				// of text
    int height;				// of text
public:
    PanelButton(const char *, ButtonState *, void *);
    void Redraw(Coord, Coord, Coord, Coord);
    void Reconfig();
    void Refresh();
    void Press() {};			// Default nothing.
};


class ButtonReplot : public PanelButton {
public:
    void Press();
};

class ButtonPrevious : public PanelButton {
public:
    void Press();
};

class ButtonNext : public PanelButton {
public:
    void Press();
};

class ButtonNewView : public PanelButton {
public:
    void Press();
};

class ButtonDeleteView : public PanelButton {
public:
    void Press();
};

class ButtonDeleteAll : public PanelButton {
public:
    void Press();
};

class ButtonQuit : public PanelButton {
public:
    void Press();
};
    
class ButtonNormalize : public PanelButton {
public:
    void Press();
};

class ButtonMagnify : public PanelButton {
public:
    void Press();
};

class ButtonOneToOne : public PanelButton {
public:
    void Press();
};

#endif /* panel_h */


