/*
 * main.c
 */

#include <IV-look/button.h>
#include <IV-look/kit.h>
#include <InterViews/background.h>
#include <InterViews/box.h>
#include <InterViews/center.h>
#include <InterViews/display.h>
#include <InterViews/glue.h>
#include <InterViews/bitmap.h>
#include <InterViews/color.h>
#include <InterViews/label.h>
#include <InterViews/margin.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/action.h>
#include <InterViews/stencil.h>
#include <InterViews/canvas.h>
#include <InterViews/deck.h>
#include <InterViews/border.h>
#include <InterViews/patch.h>
#include <InterViews/brush.h>
#include <InterViews/shapeof.h>


#include <OS/string.h>
#include <stdio.h>

#include "query.h"

static PropertyData props[] = {
    { nil }
};

static OptionDesc options[] = {
    { nil }
};

int main(int argc, char** argv) {
  Session* session = new Session("Alert", argc, argv, options, props);
  Style* style = session->style();
  Display* d = session->default_display();

  Brush* b = new Brush(2.0);     	 // drawing thickness
  const Color* c = style->foreground();  // drawing color
  Color* f = nil;      	       	   	 // fill color
  
  static Coord x1[] = { 40, 100, 100, 80, 20 };
  static Coord y1[] = { 40, 60, 140, 140, 80 };

  static Coord x2[] = { 50, 200, 170, 50 };
  static Coord y2[] = { 50, 50, 170, 200 };

  static Coord x3[] = { 55, 195, 175, 55 };
  static Coord y3[] = { 55, 55, 175, 195 };

  static Coord x4[] = { 15, 45, 85, 15 };
  static Coord y4[] = { 15, 15, 55, 95 };

  Glyph* graphics =

   new Background(
   new Overlay(
   new Neighborhood(b, c, f, x2, y2, sizeof(x2) / sizeof(Coord), "WC1"),
   new Neighborhood(b, c, f, x3, y3, sizeof(x3) / sizeof(Coord), "WC2"),
   new Neighborhood(b, c, f, x4, y4, sizeof(x4) / sizeof(Coord), "EC1"),

   new Street(b, c, f, x1, y1, sizeof(x1) / sizeof(Coord), "Oxford Street") ),
   style->flat()
       );

  TopLevelWindow* window = new TopLevelWindow(graphics);
  window->name("Oxford Street");
  window->place(d->width() / 2, d->height() / 2);
  window->align(0.5, 0.5);
  window->map();

  session->run();

  delete session;
  return 0;
}
