
/*
 * query.c
 */

#include <InterViews/background.h>
#include <InterViews/box.h>
#include <InterViews/center.h>
#include <InterViews/display.h>
#include <InterViews/glue.h>
#include <InterViews/margin.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/action.h>
#include <InterViews/canvas.h>
#include <InterViews/deck.h>
#include <InterViews/border.h>
#include <InterViews/patch.h>
#include <InterViews/shapeof.h>
#include <InterViews/fixedspan.h>
#include <InterViews/brush.h>
#include <InterViews/color.h>
#include <InterViews/event.h>

#include <IV-look/menu.h>
#include <IV-look/button.h>
#include <IV-look/kit.h>

#include <OS/list.h>
#include <OS/string.h>

#include <stdio.h>

#include "figure.h"
#include "query.h"

Street::Street(
	const Brush* brush, const Color* stroke, const Color* fill,
	Coord* x, Coord* y, int count, char* name)
	: Polyline(brush, stroke, fill, x, y, count, Event::any) 
{
  _name = name;
}	       

void Street::press(Event&)
{
  printf("Street::event() %s\n", _name);
}

Neighborhood::Neighborhood(
        const Brush* brush, const Color* stroke, const Color* fill,
        Coord* x, Coord* y, int count, char* name
	) : Polygon(brush, stroke, fill, x, y, count, Event::any)
{
  _name = name;
}	       

void Neighborhood::press(Event&)
{
  printf("Neighborhood::event() %s\n", _name);
}


// end
