/*
 * Copyright (c) 1991 Redwood Design Automation
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Redwood Design Automation may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission of
 * Redwood Design Automation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL REDWOOD DESIGN AUTOMATION BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#ifndef r_h
#define r_h

#define rInc(name) <name.h>

#include <iostream.h>
#ifdef SABER_CXX
extern "C" {
  int saber_stop(char*);
}
#define rError() saber_stop("")
#define _rCheck(ty, ex) {\
  if (! (ex)) {\
    cerr << ty << " failed: file " << __FILE__ << " line " << __LINE__ << endl;\
    rError();\
  }\
}
#define rCheck(ty, ex) _rCheck(ty, ex)
#else
#include <assert.h>
#define rError() exit(1)
#define rCheck(ty, ex) assert(ex)
#endif

#define rInvariant(ex) rCheck("Invariant", ex)
#define rPrecondition(ex) rCheck("Precondition", ex)
#define rPostcondition(ex) rCheck("Postcondition", ex)
#define rAssert(ex) rCheck("Assert", ex)
#define rFail(st) {\
  cerr << "Software Failure: " << st << endl;\
  rError();\
}

enum rBoolean { rFalse, rTrue };

#endif
