#include "peer.h"
#include <iostream.h>
#include <stdlib.h>		/* for atoi */

// Exchange an integer with a peer process using simultaneous two-way
// RPC.  The peer process's current directory will have to be the same
// as your current directory unless you set <path> to an absolute
// pathname instead of "./.peer.1".  The peer process's machine will
// have to be the same as your machine unless both machines share
// <path>'s filesystem.

int main(int argc, char** argv) {
    int n = argc > 1 ? atoi(argv[1]) : 0;
    char* path = argc > 2 ? argv[2] : "./.peer.1";

    if (n < 1) {
	cerr << "usage: " << argv[0] << " integer [path]\n";
	return 1;
    }

    Peer peer = Peer(path);

    cerr << n << " <-> " << peer.exchange(n) << "\n";

    return 0;
}
