#include "peer.h"
#include "reader.h"
#include <Dispatch/rpchdr.h>
#include <Dispatch/rpcstream.h>

// Set up the function table for a single RPC call.

Reader::Reader(rpcstream* client, Peer* peer) : RpcReader(client, NFCNS),
    peer_(peer)
{
    _function[SEND] = &Reader::send;
}

Reader::~Reader() {}

// Normally we'd do some cleanup here, but we quit running so fast
// this function never has a chance to be called.  We still have to
// implement it anyway since it's a pure virtual function.

void Reader::connectionClosed(int) {}

// Receive an integer from the peer.

void Reader::send(RpcReader* reader, RpcHdr&, rpcstream& client) {
    int n;
    if (client >> n) {
	((Reader*)reader)->peer_->remote_n(n);
    } else {
	cerr << "Reader: error receiving integer from peer\n";
	((Reader*)reader)->peer_->quitRunning();
    }
}
