#include <Dispatch/rpcstream.h>
#include <string.h>

int main(int argc, char** argv) {
    boolean binary = (argc > 1 && argv[1][0] == 'b');
    boolean swapped = (argc > 2 && argv[2][0] == 's');

    rpcstream printer;
    printer.attach(1);
    printer.binary(binary);
    printer.swapped(swapped);

    char cmd[6];
    while (cout << "> " && cin >> cmd) {
	if (strcmp(cmd, "c") == 0) {
	    char c;
	    cin >> c;
	    printer << cmd << c;
	}
	else if (strcmp(cmd, "uc") == 0) {
	    unsigned char uc;
	    cin >> uc;
	    printer << cmd << uc;
	}
	else if (strcmp(cmd, "s") == 0) {
	    short s;
	    cin >> s;
	    printer << cmd << s;
	}
	else if (strcmp(cmd, "us") == 0) {
	    unsigned short us;
	    cin >> us;
	    printer << cmd << us;
	}
	else if (strcmp(cmd, "i") == 0) {
	    int i;
	    cin >> i;
	    printer << cmd << i;
	}
	else if (strcmp(cmd, "ui") == 0) {
	    unsigned int ui;
	    cin >> ui;
	    printer << cmd << ui;
	}
	else if (strcmp(cmd, "l") == 0) {
	    long l;
	    cin >> l;
	    printer << cmd << l;
	}
	else if (strcmp(cmd, "ul") == 0) {
	    unsigned long ul;
	    cin >> ul;
	    printer << cmd << ul;
	}
	else if (strcmp(cmd, "f") == 0) {
	    float f;
	    cin >> f;
	    printer << cmd << f;
	}
	else if (strcmp(cmd, "d") == 0) {
	    double d;
	    cin >> d;
	    printer << cmd << d;
	}
	else if (strcmp(cmd, "p") == 0) {
	    char p[80];
	    cin.getline(p, sizeof(p), '\n');
	    printer << cmd << p;
	}
	else if (strcmp(cmd, "up") == 0) {
	    unsigned char up[80];
	    cin.getline(up, sizeof(up), '\n');
	    printer << cmd << up;
	}
	else if (strcmp(cmd, "flush") == 0) {
	    printer.flush();
	}

	if (!printer) {
	    cout << "printer failure" << endl;
	}
    }

    return 0;
}
