#include <Dispatch/rpcstream.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv) {
    int port = atoi(argv[1]);
    boolean nonblocking = (argc > 2 && argv[2][0] == 'n');
    boolean binary = (argc > 3 && argv[3][0] == 'b');

    rpcstream reader;
    reader.listen(port);
    int fd = reader.accept();
    reader.close();
    reader.attach(fd);
    reader.negotiate(binary);
    reader.nonblocking(nonblocking);

    char cmd[6];
    while (reader >> cmd) {
	if (strcmp(cmd, "c") == 0) {
	    char c;
	    reader >> c;
	    cout << c << endl;
	}
	else if (strcmp(cmd, "uc") == 0) {
	    unsigned char uc;
	    reader >> uc;
	    cout << uc << endl;
	}
	else if (strcmp(cmd, "s") == 0) {
	    short s;
	    reader >> s;
	    cout << s << endl;
	}
	else if (strcmp(cmd, "us") == 0) {
	    unsigned short us;
	    reader >> us;
	    cout << us << endl;
	}
	else if (strcmp(cmd, "i") == 0) {
	    int i;
	    reader >> i;
	    cout << i << endl;
	}
	else if (strcmp(cmd, "ui") == 0) {
	    unsigned int ui;
	    reader >> ui;
	    cout << ui << endl;
	}
	else if (strcmp(cmd, "l") == 0) {
	    long l;
	    reader >> l;
	    cout << l << endl;
	}
	else if (strcmp(cmd, "ul") == 0) {
	    unsigned long ul;
	    reader >> ul;
	    cout << ul << endl;
	}
	else if (strcmp(cmd, "f") == 0) {
	    float f;
	    reader >> f;
	    cout << f << endl;
	}
	else if (strcmp(cmd, "d") == 0) {
	    double d;
	    reader >> d;
	    cout << d << endl;
	}
	else if (strcmp(cmd, "p") == 0) {
	    char p[80];
	    reader >> p;
	    cout << p << endl;
	}
	else if (strcmp(cmd, "up") == 0) {
	    unsigned char up[80];
	    reader >> up;
	    cout << (char*)up << endl;
	}

	if (!reader.good()) {
	    cout << "reader eof or failure" << endl;
	}
    }

    return 0;
}
