#include <Dispatch/rpcstream.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv) {
    char* host = argv[1];
    int port = atoi(argv[2]);
    boolean binary = (argc > 3 && argv[3][0] == 'b');

    rpcstream writer;
    writer.connect(host, port);
    writer.negotiate(binary);

    char cmd[6];
    while (cout << "> " && cin >> cmd) {
	if (strcmp(cmd, "c") == 0) {
	    char c;
	    cin >> c;
	    writer << cmd << c;
	}
	else if (strcmp(cmd, "uc") == 0) {
	    unsigned char uc;
	    cin >> uc;
	    writer << cmd << uc;
	}
	else if (strcmp(cmd, "s") == 0) {
	    short s;
	    cin >> s;
	    writer << cmd << s;
	}
	else if (strcmp(cmd, "us") == 0) {
	    unsigned short us;
	    cin >> us;
	    writer << cmd << us;
	}
	else if (strcmp(cmd, "i") == 0) {
	    int i;
	    cin >> i;
	    writer << cmd << i;
	}
	else if (strcmp(cmd, "ui") == 0) {
	    unsigned int ui;
	    cin >> ui;
	    writer << cmd << ui;
	}
	else if (strcmp(cmd, "l") == 0) {
	    long l;
	    cin >> l;
	    writer << cmd << l;
	}
	else if (strcmp(cmd, "ul") == 0) {
	    unsigned long ul;
	    cin >> ul;
	    writer << cmd << ul;
	}
	else if (strcmp(cmd, "f") == 0) {
	    float f;
	    cin >> f;
	    writer << cmd << f;
	}
	else if (strcmp(cmd, "d") == 0) {
	    double d;
	    cin >> d;
	    writer << cmd << d;
	}
	else if (strcmp(cmd, "p") == 0) {
	    char p[80];
	    cin.getline(p, sizeof(p), '\n');
	    writer << cmd << p;
	}
	else if (strcmp(cmd, "up") == 0) {
	    unsigned char up[80];
	    cin.getline(up, sizeof(up), '\n');
	    writer << cmd << up;
	}
	else if (strcmp(cmd, "flush") == 0) {
	    writer.flush();
	}

	if (!writer.good()) {
	    cout << "writer eof or failure" << endl;
	}
    }

    return 0;
}
