/*
 * Copyright (c) 1991 Redwood Design Automation
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Redwood Design Automation may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission of
 * Redwood Design Automation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL REDWOOD DESIGN AUTOMATION BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#ifndef ruiDrag_h
#define ruiDrag_h

class Window;
class ManagedWindow;
class Glyph;
class Event;
class XEvent;

class ruiDrag {
public:
  // these are used to initiate a drag.
  static void dragAndDrop(Glyph* glyph, char* value);
  static void dragAndDrop(Window* window, Glyph* glyph, char* value);

  // this is used to detect a drop.
  static boolean isDrag(const Event& event);

  // this is used to get the value from a drop.
  static boolean value(const Event& event, char*& value);

  // these are used to detect and interpret a drag and drop client message.
  static boolean isDrag(const XEvent& xevent);
  static void locate(const XEvent& xevent, int& x, int& y);

protected:
  static void sendClientMessage(Window* window, char* value, int x, int y);

  static unsigned uid_;
  static const char* dragName_;
  static ManagedWindow* window_;
};

#endif
