/*
 * Copyright (c) 1991 Redwood Design Automation
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Redwood Design Automation may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission of
 * Redwood Design Automation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL REDWOOD DESIGN AUTOMATION BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#ifndef ruiKeyMap_h
#define ruiKeyMap_h

#include <InterViews/handler.h>
#include <InterViews/monoglyph.h>

class ruiKeyMapInfo;
class ruiKeyMapInfoArray;

typedef unsigned int ruiKeyMapModifier;

class ruiKeyMap : public MonoGlyph, public Handler {
public:
  enum {none = 0, control = 1, meta = 2, shift = 4, capslock = 8};

  ruiKeyMap(Glyph* glyph);
  virtual ~ruiKeyMap();

  virtual void pick(Canvas* canvas, const Allocation& allocation, int depth,
    Hit& hit);
  virtual boolean caught(const Event& event) const;
  virtual void event(Event& event);

  virtual void add(Action* action, char* string);
  virtual void add(Action* action, char keycode, ruiKeyMapModifier modifiers =
    none);

protected:
  ruiKeyMapModifier modifiers(const Event& event) const;
  ruiKeyMapInfo* lookup(const Event& event) const;

  ruiKeyMapInfoArray* info_;
};

#endif
