#ifndef ruiPanner_h
#define ruiPanner_h

#include <InterViews/handler.h>
#include <InterViews/listener.h>

#include <IV-look/adjuster.h>

class Style;

class ruiPanner : public Listener, public Adjuster, public Handler {
public:
    enum Direction { leftToRight = 1, rightToLeft = 0, bottomToTop = 2,
        topToBottom = 0 };

    ruiPanner(Adjustable* x, Adjustable* y, Style*, Direction d =
        (Direction) (leftToRight | bottomToTop));
    virtual ~ruiPanner();

    virtual void request(Requisition&) const;
    virtual void allocate(Canvas*, const Allocation&, Extension&);
    virtual void draw(Canvas*, const Allocation&) const;

    virtual void update(DimensionName);
    virtual void update_all();

    virtual void event(Event&);

protected:
    void damage_thumb();

    Adjustable* y_adjust_;
    Glyph* thumb_;
    Canvas* canvas_;
    Allocation allocation_;
    Allocation thumb_allocation_;
    float xscale_, yscale_;
    Direction direction_;
};

#endif
