/*
 * Copyright (c) 1991 Redwood Design Automation
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Redwood Design Automation may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission of
 * Redwood Design Automation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL REDWOOD DESIGN AUTOMATION BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#ifndef ruiTextEdit_h
#define ruiTextEdit_h

#include <InterViews/action.h>
#include <InterViews/monoglyph.h>

#include <rutString.h>

class Kit;
class Style;

class ruiText;
class ruiLegend;

class ruiTextEdit : public MonoGlyph {
public:
  ruiTextEdit(Kit* kit, Style* style);
  virtual ~ruiTextEdit();

  virtual void load();
  virtual void save();

  virtual void search();
  virtual void again();
  virtual void searchAndReplace();

  virtual void cursorUp();
  virtual void cursorDown();
  virtual void cursorLeft();
  virtual void cursorRight();

  virtual void scrollUp();
  virtual void scrollDown();
  virtual void scrollLeft();
  virtual void scrollRight();

  virtual void pageUp();
  virtual void pageDown();

  virtual void home();
  virtual void end();

  virtual void font(char* name);

protected:
  virtual boolean searchPattern(const rutString& pattern);

  ruiText* text_;
  rutString pattern_;
  rutString replacement_;
  ruiLegend* legend_;
};

declare(ActionCallback, ruiTextEdit);

#endif
