/*
 * Copyright (c) 1991 Redwood Design Automation
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Redwood Design Automation may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission of
 * Redwood Design Automation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL REDWOOD DESIGN AUTOMATION BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

// This may look like C code, but it is really -*- C++ -*-

// A Bison++ parser, made from rutLexParse.y 

#ifndef RUTLEXPARSE_Y 

#define RUTLEXPARSE_Y 

#line 1 "rutLexParse.y"


#include <rutLex.h>

class rutLexParseBase {
protected:
  rutLexRegExpNode* expression_;
};

typedef union {
  rutLexRegExpNode* node;
  rutLexSet* set;
  char character;
  int integer;
} rutLexParse_YYSTYPE;

typedef
  struct rutLexParse_YYLTYPE {
   int timestamp;
   int first_line;
   int first_column;
   int last_line;
   int last_column;
   char *text;
};

class rutLexParse : public rutLexParseBase {
protected:
   int yychar;
   rutLexParse_YYSTYPE yylval;
   rutLexParse_YYLTYPE yylloc;
   int yynerrs;
public:
  rutLexParse() {};
  int yyparse();
  virtual void yyerror(char *);
  virtual int yylex();
  static const int	eConcat;
  static const int	sConcat;
  static const int	openClosure;
  static const int	openGroup;
  static const int	openSet;
  static const int	eUnion;
  static const int	zeroOrMore;
  static const int	oneOrMore;
  static const int	zeroOrOne;
  static const int	teConcat;
  static const int	openTag;
  static const int	closeTag;
  static const int	closeClosure;
  static const int	closureRange;
  static const int	closeGroup;
  static const int	closeSet;
  static const int	notSet;
  static const int	setRange;
  static const int	any;
  static const int	alpha;
  static const int	digit;
  static const int	other;

};

#endif RUTLEXPARSE_Y
