/*
 * Copyright (c) 1990 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * Unique schematic capture system class identifiers
 */

#ifndef scmclasses_h
#define scmclasses_h

#include <Unidraw/classes.h>

#define EXAMINE_TOOL             2000
#define NEWVIEW_CMD              2001
#define	ELEMENT_VAR              2002
#define ALIAS_COMP       	 2003
#define TOGGLEDWGPALETTE_CMD     2004
#define ELEMENT_COMP             2005
#define ALIAS_CMD                2007
#define NEWTOOL_CMD              2008
#define TOOLS_CMD                2009
#define DEFINITION_CMD           2010
#define NETLIST_VIEW             2011
#define NETLIST_CMD              2012
#define NODE_VAR                 2013
#define WIRE_COMP                2014
#define NODE_COMP                2015
#define INFO_CMD                 2016
#define LOGIC_COMP               2017
#define BULB_COMP                2018
#define SWITCH_COMP              2019
#define MANIPULATE_TOOL          2020
#define TRUTHTABLE_CMD           2021
#define TF_TRUTHTABLE            2022
#define INSTANCE_COMP            2023
#define INSTANCE_TOOL            2024

/* Composite ids associating subjects with their views */

#define ALIAS_VIEW          Combine(ALIAS_COMP, COMPONENT_VIEW)
#define BULB_VIEW           Combine(BULB_COMP, COMPONENT_VIEW)
#define ELEMENT_VIEW        Combine(ELEMENT_COMP, COMPONENT_VIEW)
#define INSTANCE_VIEW       Combine(INSTANCE_COMP, COMPONENT_VIEW)
#define NL_ALIAS            Combine(ALIAS_COMP, NETLIST_VIEW)
#define NL_ELEMENT          Combine(ELEMENT_COMP, NETLIST_VIEW)
#define NL_GRAPHIC_COMPS    Combine(GRAPHIC_COMPS, NETLIST_VIEW)
#define NL_NODE             Combine(NODE_COMP, NETLIST_VIEW)
#define NODE_VIEW           Combine(NODE_COMP, COMPONENT_VIEW)
#define SWITCH_VIEW         Combine(SWITCH_COMP, COMPONENT_VIEW)
#define WIRE_VIEW           Combine(WIRE_COMP, COMPONENT_VIEW)

#endif
