/*
 * Copyright (c) 1990 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * Schematic capture system keycode values.
 */

#include "scmkybd.h"

const char* KLBL_ALIAS           = "^E", *CODE_ALIAS                 = "\005";
const char* KLBL_BULB            = "B",  *CODE_BULB                  = "B";
const char* KLBL_DEFINITION      = "^W", *CODE_DEFINITION            = "\027";
const char* KLBL_EXAMINE         = "E",  *CODE_EXAMINE               = "E";
const char* KLBL_FIX             = "F",  *CODE_FIX                   = "F";
const char* KLBL_FLOAT           = "^F", *CODE_FLOAT                 = "\006";
const char* KLBL_INFO            = "I",  *CODE_INFO                  = "I";
const char* KLBL_MANIP           = "M",  *CODE_MANIP                 = "M";
const char* KLBL_NETLIST         = "N",  *CODE_NETLIST               = "N";
const char* KLBL_NEWTOOL         = "^T", *CODE_NEWTOOL               = "\024";
const char* KLBL_NEWVIEW         = "V",  *CODE_NEWVIEW               = "V";
const char* KLBL_SWITCH          = "W",  *CODE_SWITCH                = "W";
const char* KLBL_TOGGLEDWGPALETTE= "D",  *CODE_TOGGLEDWGPALETTE      = "D";
const char* KLBL_TOOLS           = "T",  *CODE_TOOLS                 = "T";
const char* KLBL_TRUTHTABLE      = "#",  *CODE_TRUTHTABLE            = "#";
