/*
 * Copyright (c) 1990 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * Schematic capture system-specific transfer functions.
 */

#ifndef scmtransfns_h
#define scmtransfns_h

#include <Unidraw/transfn.h>

class TruthTable;

class TF_TruthTable : public TransferFunct {
public:
    TF_TruthTable(TruthTable* = nil);
    virtual ~TF_TruthTable();

    virtual void Evaluate(Path* = nil);

    TruthTable* GetTruthTable();
    void SetTruthTable(TruthTable*);

    virtual TransferFunct* Copy();
    virtual void Read(istream&);
    virtual void Write(ostream&);
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
private:
    unsigned GetInputs();
private:
    TruthTable* _truth;
};

inline TruthTable* TF_TruthTable::GetTruthTable () { return _truth; }
inline void TF_TruthTable::SetTruthTable (TruthTable* t) { _truth = t; }

#endif
