#include <InterViews/background.h>
#include <InterViews/box.h>
#include <InterViews/image.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/tiff.h>
#include <InterViews/window.h>

#include <IV-look/button.h>
#include <IV-look/choice.h>
#include <IV-look/kit.h>

#include <ruiScene.h>
#include <ruiPanner.h>

int main(int argc, char** argv) {
    Session* session = new Session("test", argc, argv);
    Kit* kit = Kit::instance();
    Style* style = session->style();

    ruiScene* scene = new ruiScene;

// replace this with whatever you want...
    scene->append(new Button(nil, new ChoiceItem(
        new Image(TIFFRaster::load("tif/femmeblue.tif")),
        new Image(TIFFRaster::load("tif/dinoparts.tif")))));
    scene->show(0, true);

    ruiPanner* panner = new ruiPanner(scene, scene, style);

    ApplicationWindow* window = new ApplicationWindow(new Background(
        new LRBox(scene, panner), style->background()));
    window->map();

    session->run();

    return 0;
}
