/* Copyright (c) 1991 by Sanjay Ghemawat */
#include <InterViews/message.h>
#include <InterViews/box.h>
#include "command.h"
#include "game.h"
#include "hiliteglue.h"

Command::Command(const char* str, Game* g, GameCommand c) : (str, Left) {
    game = g;
    command = c;
}

Command::Command(const char* s1, const char* s2, Game* g, GameCommand c)
     : (new HBox(new HiliteHGlue(round(0.5 * cm), 0),
		 new Message(s1),
		 new HiliteHGlue(round(0.5 * cm)),
		 new Message(s2),
		 new HiliteHGlue(round(0.5 * cm), 0)
		 ))
{
    game = g;
    command = c;
}

void Command::Do() {
    (game->*command)();
}
