/* This may look like C code, but it is really -*- C++ -*- */
/* Copyright (c) 1991 by Sanjay Ghemawat. */

#ifndef LABELH
#define LABELH

#include <InterViews/subject.h>
#include <InterViews/interactor.h>

class FieldState;

/* A Label displays the state of some Field (see field.h) */
class Label : public Interactor {
  public:
    Label(FieldState*,              Alignment = Left, char* format = "");
    Label(const char*, FieldState*, Alignment = Left, char* format = "");
    Label(Painter*, FieldState*,    Alignment = Left, char* format = "");
    virtual ~Label();

    void SetFormat(char*);
    char*GetFormat();

    void SetAlignment(Alignment);
    Alignment GetAlignment();

    virtual void Redraw(Coord,Coord,Coord,Coord);

    virtual void Refresh();	/* Redraw stuff */
    virtual void Update();	/* Handle change in associated StringState */
    virtual void Reconfig();	/* Handle changes in shapes and stuff */
  protected:
    FieldState* subject;	/* Associated string */
    char*       minformat;	/* String whose width is to be used as min */
    int         minwidth;	/* Minimum width of field */
    Alignment	align;
  private:
    void Init(FieldState*,Alignment,char*);/* Initialize structure */
};

#endif /*LABELH */
