/* Copyright (c) 1991 by Sanjay Ghemawat. */

#include "objects.h"

/* Description of all objects in all possible rotations */

ObjectDesc objects[NumObjectTypes] = {
    /* Thin object */
    {
	{ {-1,  0}, { 0,  0}, { 1,  0}, { 2,  0} }, /* Not rotated */
	{ { 0, -1}, { 0,  0}, { 0,  1}, { 0,  2} }, /* Rotated 90 */
	{ {-1,  0}, { 0,  0}, { 1,  0}, { 2,  0} }, /* Rotated 180 */
	{ { 0, -1}, { 0,  0}, { 0,  1}, { 0,  2} }  /* Rotated 270 */
    },
    /* Blob */
    {
	{ { 0,  0}, { 1,  0}, { 0,  1}, { 1,  1} },
	{ { 0,  0}, { 1,  0}, { 0,  1}, { 1,  1} },
	{ { 0,  0}, { 1,  0}, { 0,  1}, { 1,  1} },
	{ { 0,  0}, { 1,  0}, { 0,  1}, { 1,  1} }
    },
    /* ZigLeft */
    {
	{ {-1,  1}, { 0,  0}, { 0,  1}, { 1,  0} },
	{ {-1, -1}, {-1,  0}, { 0,  0}, { 0,  1} },
	{ {-1,  1}, { 0,  0}, { 0,  1}, { 1,  0} },
	{ {-1, -1}, {-1,  0}, { 0,  0}, { 0,  1} }
    },
    /* ZigRight */
    {
	{ {-1,  0}, { 0,  1}, { 0,  0}, { 1,  1} },
	{ { 0, -1}, { 0,  0}, {-1,  0}, {-1,  1} },
	{ {-1,  0}, { 0,  1}, { 0,  0}, { 1,  1} },
	{ { 0, -1}, { 0,  0}, {-1,  0}, {-1,  1} }
    },
    /* Tee */
    {
	{ { 0,  0}, {-1,  0}, { 1,  0}, { 0, -1} },
	{ { 0,  0}, { 0, -1}, { 0,  1}, {-1,  0} },
	{ { 0,  0}, {-1,  0}, { 1,  0}, { 0,  1} },
	{ { 0,  0}, { 0, -1}, { 0,  1}, { 1,  0} }
    },
    /* ElLeft */
    {
	{ {-1, -1}, {-1,  0}, { 0,  0}, { 1,  0} },
	{ {-1,  1}, { 0,  1}, { 0,  0}, { 0, -1} },
	{ { 1,  1}, { 1,  0}, { 0,  0}, {-1,  0} },
	{ { 1, -1}, { 0, -1}, { 0,  0}, { 0,  1} }
    },
    /*ElRight */
    {
	{ { 1, -1}, {-1,  0}, { 0,  0}, { 1,  0} },
	{ {-1, -1}, { 0,  1}, { 0,  0}, { 0, -1} },
	{ {-1,  1}, { 1,  0}, { 0,  0}, {-1,  0} },
	{ { 1,  1}, { 0, -1}, { 0,  0}, { 0,  1} }
    }
};
