/* This may look like C code, but it is really -*- C++ -*- */
/* Copyright (c) 1991 by Sanjay Ghemawat. */

#ifndef OBJECTSH
#define OBJECTSH

/* Miscellaneous stuff for tetris objects */

/* Types of objects */
enum ObjectType {
    Thin	=0,
    Blob	=1,
    ZigLeft	=2,
    ZigRight	=3,
    Tee		=4,
    ElLeft	=5,
    ElRight	=6
};

#define NumObjectTypes	7

#define NumObjectDivs	4	/* Number of unit squares per object */

/* Location of a filled square in an object - offset from object center */
struct ObjectDiv {
    short x, y;
};

/* An object consists of NumObjectDivs filled unit squares */
typedef ObjectDiv Object[NumObjectDivs];

/* Four possible orientations for an object */
#define NumRotations	4

typedef enum {
    R0	=0,			/* Not rotated */
    R90	=1,			/* Rotated 90 degrees */
    R180=2,			/* Rotated 180 degrees */
    R270=3			/* Rotated 270 degress */
} Rotation;

/* Description of object in all rotated forms */
typedef Object	ObjectDesc[NumRotations];

extern ObjectDesc	objects[NumObjectTypes];

/* Type of a square in a game */
typedef enum { Occupied, Empty } Square;

#endif /*OBJECTSH */
