/* This may look like C code, but it is really -*- C++ -*- */
/* Copyright (c) 1991 by Sanjay Ghemawat. */

#ifndef PBOARDH
#define PBOARDH

/* An interactor that displays a board of squares. */
/* Keeps track of what is on screen for minimal update. */

#include "objects.h"
#include <InterViews/interactor.h>

class PBoard : public Interactor {
  public:
    PBoard(Square** src, int ht, int wd, int size);
    virtual ~PBoard();

    void	Clear();
    void	Refresh();
  protected:
    virtual void Redraw(Coord, Coord, Coord, Coord);
    virtual void Reconfig();

    int		width, height;
    int		block_size;
    Square**	source;
    Square**	backing_store;
};

#endif /*PBOARDH */
