/*
 * Copyright (c) 1991, 1992, Jonathan P. Leech
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice and this permission notice appear in
 * all copies of the software and related documentation.
 *
 */

#ifndef ivlook_multibutton_h
#define ivlook_multibutton_h

#include <IV-look/button.h>
#include <InterViews/observe.h>
#include <select.h>

class String;
class Glyph;
class Event;

class MultiButton : public Button {
public:
    MultiButton(Glyph *, Style *, TelltaleState *, Selectable *, unsigned);

    // Button overrides
    virtual void update(Observable *);
    virtual void release(const Event &e);

    // 3.0 libgmodel compatibility hack
    static MultiButton *simple_multi_button(const char *str, Selectable *, unsigned) const;

    static MultiButton *multi_button(const char *str, Selectable *, unsigned);
    static MultiButton *multi_button(const String &str, Selectable *, unsigned);
    static MultiButton *multi_button(Glyph *g, Selectable *, unsigned);
private:
    Selectable *selectable_;
    unsigned index_;		// Value when selected
};

#endif /*ivlook_multibutton_h*/
