/*
 * Copyright (c) 1991, 1992, Jonathan P. Leech
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice and this permission notice appear in
 * all copies of the software and related documentation.
 *
 */

#ifndef ivlook_togglebutton_h
#define ivlook_togglebutton_h

#include <IV-look/button.h>
#include <InterViews/observe.h>
#include <select.h>

class String;
class Glyph;
class Event;

class ToggleButton : public Button {
public:
    ToggleButton(Glyph *, Style *, TelltaleState *, Selectable *);

    // Button overrides
    virtual void update(Observable *);
    virtual void release(const Event &e);

    Selectable *selectable();

    static ToggleButton *toggle_button(const char *str, Selectable *);
    static ToggleButton *toggle_button(const String &str, Selectable *);
    static ToggleButton *toggle_button(Glyph *g, Selectable *);
private:
    Selectable *selectable_;
};

#endif /*ivlook_togglebutton_h*/
