// This file is part of xplot.
// 
// Copyright (C) 1989 Rene' Seindal (seindal@diku.dk)
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


#ifndef version_h
#define version_h

class Version;				// A class to extract info from RCS keywords.

class Version {
private:
    const char *date;
    const char *revision;
    const char *author;
    const char *state;
    const char *pretty;

    const char *Duplicate(const char *s, int len);
    const char *GetText(const char *src);
public:
    Version();
    ~Version();

    const char *Date();
    const char *Revision();
    const char *Author();
    const char *State();

    const char *PrettyVersion();
};

#endif /* version_h */
